
#include "interface.h"
#include "zbrane.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "prekazka.h"
#include "zbrane.h"
#include "vec.h"
#include "animacia.h"
#include "robot.h"
#include "teleport.h"
#include "trubky.h"
#include "zvuky.h"
#include "nastaveniaSiete.h"

#ifdef NET_MULTIPLAYER
#include "siet.h"
#endif

bulanec **armadaBulancov;

static SDL_Surface *g_bulanec8[POCET_FARIEB_BULANCOV];
static SDL_Surface *g_bulanec6[POCET_FARIEB_BULANCOV];
static SDL_Surface *g_bulanec4[POCET_FARIEB_BULANCOV];
static SDL_Surface *g_bulanec2[POCET_FARIEB_BULANCOV];
static SDL_Surface *g_kriz;

void initBulanec()
{
	int i;
	char str[STR_SIZE];


	for(i=0;i<POCET_FARIEB_BULANCOV;i++)
	{
		sprintf(str,PATH_IMAGE "tux1%c.png",'a'+i);
		g_bulanec8[i] = loadImage(str,1);

		sprintf(str,PATH_IMAGE "tux2%c.png",'a'+i);
		g_bulanec4[i] = loadImage(str,1);

		sprintf(str,PATH_IMAGE "tux4%c.png",'a'+i);
		g_bulanec6[i] = loadImage(str,1);

		sprintf(str,PATH_IMAGE "tux3%c.png",'a'+i);
		g_bulanec2[i] = loadImage(str,1);
	}

	g_kriz = loadImage(PATH_IMAGE "kriz.png",1);
}

bulanec *getbulanec(int n)
{
	int i;

	if(armadaBulancov==NULL)
	{
		fprintf(stderr,"ziadny zaznam o tuxankoch nie je\n");
		return NULL;
	}

	for(i=0;armadaBulancov[i]!=NULL;i++)
		if(armadaBulancov[i]->id==n)return armadaBulancov[i];

	fprintf(stderr,"tuxanec s id %d nenajdeny!\n",n);

	return NULL;
}

int getPocetBulancov()
{
	int i;
	int ret=0;

	if(armadaBulancov==NULL)return 0;

	for(i=0;armadaBulancov[i]!=NULL;i++)
		ret++;

	return ret;
}

void kresliBulanec(bulanec *s)
{
	int x,y,w,h;
	int nakreslim=1;
	int farba;
	SDL_Surface *poloha=NULL;

	if(s->vidiet!=0)return;
	//Takovy smer neznam, nebudu ho kreslit, nejspis neznam jeho pozici
	if (s->otoceny == 0) return;

	getRozmeryGrafika(s,&x,&y,&w,&h);

	if(s->mrtvy==0)
	{
		farba = s->id;

		while(farba>=POCET_FARIEB_BULANCOV)
		{
			farba-=POCET_FARIEB_BULANCOV;
		}

		switch(s->otoceny)
		{
			case HORE: poloha=g_bulanec8[farba]; break;
			case VPRAVO: poloha=g_bulanec6[farba]; break;
			case VLAVO: poloha=g_bulanec4[farba]; break;
			case DOLE: poloha=g_bulanec2[farba]; break;
		}

		if(s->bonus==BONUS_NEVYDITELNY &&
		   s->id!=getTuxKtorehoOvladam() &&
		   getNastaveniaSieteStav()!=NONE)
		{
			nakreslim=0;
		}

		if(nakreslim)
		{
			pridajImage(&zoznamImage,poloha,x,y,
			GRAFIKA_BULANEC_SIRKA,GRAFIKA_BULANEC_VYSKA,
			GRAFIKA_BULANEC_SIRKA*(s->animaciaKrokov/POCET_KLIKNUTI_KLAVESY),0,
			GRAFIKA_BULANEC_SIRKA,GRAFIKA_BULANEC_VYSKA,VRSTVA_S_TUXANCOM,PREKRESLI_RAMEC);
		}
		else
		{
			pridajPrekresli(&zoznamPrekresli,x,y,w,h);
		}
	}
	else
	{
		pridajPrekresli(&zoznamPrekresli,x,y,w,h);

		pridajImage(&zoznamImage,g_kriz,s->x-BULANEC_SIRKA/2,s->y-BULANEC_VYSKA/2,
		KRIZ_SIZE_X,KRIZ_SIZE_Y,0,0,KRIZ_SIZE_X,KRIZ_SIZE_Y,
		VRSTVA_S_TUXANCOM,PREKRESLI_RAMEC);
	}
}

int koliziaBulancov(bulanec *p,int px,int py)
{
	int i;
	int x1,y1,w1,h1;
	int x2,y2,w2,h2;

	getRozmery(p,&x1,&y1,&w1,&h1);
	x1+=px;
	y1+=py;

	for(i=0;armadaBulancov[i]!=NULL;i++)
	{
		if(p!=armadaBulancov[i]/* && armadaBulancov[i]->mrtvy==0*/)
		{
			getRozmery(armadaBulancov[i],&x2,&y2,&w2,&h2);
			if(koliziaObdlznikov(x1,y1,w1,h1,x2,y2,w2,h2)==1)return 1;
		}
	}

	return 0;
}

int koliziaStrelaBulanec(bulanec *p)
{
	strela *teraz;
	strela *pred;
	strela *del;

	int pocet=0;
	int x,y,w,h;

	teraz=zoznamStrel;
	pred=NULL;
	
	getRozmery(p,&x,&y,&w,&h);

	while(teraz!=NULL)
	{
		if((getNastaveniaSieteStav()==NONE ||
		   (getNastaveniaSieteStav()!=NONE && getTuxKtorehoOvladam()==p->id)) &&
		    teraz->autorStreli!=p && teraz->vidiet==0 && 
		    koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,
		    teraz->w,teraz->h))
		{
			char str[STR_SIZE];

			if(p->bonus==BONUS_TELEPORT)
			{
				int x,y,w,h;
				
				getRozmery(p,&x,&y,&w,&h);
				pridajPrekresli(&zoznamPrekresli,
				x-GRAFIKA_BULANEC_SIRKA,y-GRAFIKA_BULANEC_VYSKA,
				w+GRAFIKA_BULANEC_SIRKA*2,h+GRAFIKA_BULANEC_VYSKA*2);

#ifdef NET_MULTIPLAYER
				if(getNastaveniaSieteStav()!=NONE)
				{
					sprintf(str,"prekresli %d %d %d %d",
					x-GRAFIKA_BULANEC_SIRKA,y-GRAFIKA_BULANEC_VYSKA,
					w+GRAFIKA_BULANEC_SIRKA*2,h+GRAFIKA_BULANEC_VYSKA*2);
					if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
					if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				}
#endif
				p->x=SURADNICA_ZIADNA; p->y=SURADNICA_ZIADNA;
				volnyPriestor(&p->x,&p->y,BULANEC_SIRKA,BULANEC_VYSKA);
				p->x+=BULANEC_SIRKA/2;
				p->y+=BULANEC_VYSKA/2;

#ifdef NET_MULTIPLAYER
				if(getNastaveniaSieteStav()!=NONE)
				{
					sprintf(str,"pohyb %d %d %d %d",
					p->id,p->x,p->y,p->otoceny);
					if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
					if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				}
#endif

				pred=teraz;
				teraz=teraz->next;
				continue;
			}

			if(p->mrtvy==0 && p->vidiet==0)
			{
				p->mrtvy=1;

				if(getNastaveniaSieteStav()==NONE)
				{
					if(p==armadaBulancov[ACTIVE_BULANEC1])
						armadaBulancov[ACTIVE_BULANEC2]->score++;
					if(p==armadaBulancov[ACTIVE_BULANEC2])
						armadaBulancov[ACTIVE_BULANEC1]->score++;
				}
				else
				{
#ifdef NET_MULTIPLAYER
					if(teraz->autorStreli!=NULL && teraz->autorStreli!=p)
					{
						teraz->autorStreli->score++;
						sprintf(str,"score %d %d",
						teraz->autorStreli->id,teraz->autorStreli->score);
						if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
						if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
					}
#endif
				}

#ifdef NET_MULTIPLAYER
				if(getNastaveniaSieteStav()!=NONE)
				{
					sprintf(str,"mrtvy %d",p->id);
					if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
					if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				}
#endif
				if(teraz->typ==BOMB_BALL)
				{
#ifdef NET_MULTIPLAYER
					sprintf(str,"vec %d %d %d",teraz->x-10,teraz->y-10,VYBUCH);
					if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
					if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
#endif

					pridajVec(&zoznamVeci,teraz->x-10,teraz->y-10,VYBUCH,NULL);
				}

				prehrajZvuk(ZVUK_SMRT);
			}

#ifdef NET_MULTIPLAYER
			if(getNastaveniaSieteStav()!=NONE)
			{
				sprintf(str,"odstranstrelu %d",teraz->id);
				if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
				if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
			}
#endif

			if(pred!=NULL)
			{
				pred->next=teraz->next;
				del=teraz;
				teraz=teraz->next;
				free(del);
				continue;
			}
			else
			{
				del=zoznamStrel;
				zoznamStrel=zoznamStrel->next;
				teraz=teraz->next;
				free(del);
				continue;
			}
		}

		pred=teraz;
		teraz=teraz->next;
		pocet++;
	}

	//printf("pocet=%d\n",pocet);
	return 0;
}

void akciaBulanec(bulanec *s)
{
	int x,y,w,h;
	int i;

	zobrazZbran(&zoznamVeci,s);

	if(s->vidiet>0)s->vidiet--;
	if(s->mozeStrielat>0)s->mozeStrielat--;
	if(s->mozePrehoditZbran>0)s->mozePrehoditZbran--;

	if(s->casBonus>0)s->casBonus--;

	if(s->casBonus==0 && s->bonus!=BONUS_NIC)
	{
		int n=0;

		s->bonus=BONUS_NIC;
		
		if(koliziaBulanecStena(s,0,0)==0 &&
		   koliziaBulanecAnimacia(s,0,0)==0 &&
		   koliziaBulanecTrubka(s,0,0)==0 &&
		   koliziaBulanecRobot(s,0,0)==0)
		{
			n=1;
		}
		
		if(n==0)s->bonus=BONUS_DUCH;
	}

	if(s->naboje[PISTOL]==0 && s->naboje[SAMOPAL]==0 &&
	   s->naboje[BROKOVNICA]==0 && s->naboje[BOMBA]==0 &&  
	   s->naboje[LASSER]==0 && s->naboje[BOMB_BALL]==0 &&
	   s->nabijaSaZasobnik>0)
	{
		s->nabijaSaZasobnik--;
		
		if(s->nabijaSaZasobnik==0)
		{
			s->zbran=PISTOL;
			s->naboje[PISTOL]=MAX_POCET_STRIEL;
			prehrajZvuk(ZVUK_NABYJA_SA);
		}
	}

	if(((getNastaveniaSieteStav()==NONE ||
	   (getNastaveniaSieteStav()!=NONE && getTuxKtorehoOvladam()==s->id))) && 
	    s->mrtvy>0)
	{
		s->mrtvy++;
	}

	if(s->mrtvy>=30)
	{
		zvysKolo();

		for(i=0;i<POCET_ZBRANI;i++)
			s->naboje[i]=0;
	
		s->naboje[PISTOL]=MAX_POCET_STRIEL;

		s->zbran=PISTOL;
		s->otoceny=VPRAVO;
		s->mozeStrielat=0;
		s->nabijaSaZasobnik=0;
		s->mrtvy=0;
		s->bonus=BONUS_NIC;
		s->casBonus=0;
		s->mozePrehoditZbran=0;

		getRozmeryGrafika(s,&x,&y,&w,&h);

		pridajPrekresli(&zoznamPrekresli,s->x-BULANEC_SIRKA/2,s->y-BULANEC_VYSKA/2,
		KRIZ_SIZE_X,KRIZ_SIZE_Y);

#ifdef NET_MULTIPLAYER
		if(getNastaveniaSieteStav()!=NONE)
		{
			char str[STR_SIZE];
			sprintf(str,"prekresli %d %d %d %d",
			s->x-BULANEC_SIRKA/2,s->y-BULANEC_VYSKA/2,KRIZ_SIZE_X,KRIZ_SIZE_Y);
			if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
			if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
		}
#endif
		s->x=-1; s->y=-1;
			
		volnyPriestor(&s->x,&s->y,BULANEC_SIRKA,BULANEC_VYSKA);
		s->x+=BULANEC_SIRKA/2;
		s->y+=BULANEC_VYSKA/2;

		pridajZbran();

#ifdef NET_MULTIPLAYER
		if(getNastaveniaSieteStav()!=NONE)
		{
			char str[STR_SIZE];
			sprintf(str,"pohyb %d %d %d %d",s->id,s->x,s->y,s->otoceny);
			if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
			if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
		}
#endif
	}
}

void prehodZbran(bulanec *b)
{
	int i;

	for(i=b->zbran+1;i<POCET_ZBRANI;i++)
		if(b->naboje[i]>0)
		{
			b->zbran=i;
#ifdef NET_MULTIPLAYER
			if(getNastaveniaSieteStav()!=NONE)
			{
				char str[STR_SIZE];
				sprintf(str,"zmenzbran %d %d",
				b->id,b->zbran);
				if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
			}
#endif

			return;
		}

	for(i=0;i<POCET_ZBRANI;i++)
		if(b->naboje[i]>0)
		{
			b->zbran=i;

#ifdef NET_MULTIPLAYER
			if(getNastaveniaSieteStav()!=NONE)
			{
				char str[STR_SIZE];
				sprintf(str,"zmenzbran %d %d",
				b->id,b->zbran);
				if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
			}
#endif

			return;
		}
}

void pohybBulanec(bulanec *s,int smer)
{
	if(smer != s->otoceny)
	{
		s->otoceny=smer;
		return;
	}

	s->animaciaKrokov++;
	if(s->animaciaKrokov==MAX_ANIMACIA*POCET_KLIKNUTI_KLAVESY)s->animaciaKrokov=0;

	switch(s->otoceny)
	{
		case HORE:
			if(s->y>0)s->y-=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
		case VPRAVO:
			if(s->x<HRACIA_PLOCHA_SIZE_X)s->x+=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
		case VLAVO:
			if(s->x>0)s->x-=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
		case DOLE:
			if(s->y<HRACIA_PLOCHA_SIZE_Y)s->y+=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
	}
}

void getRozmery(bulanec *p,int *x,int *y,int *w,int *h)
{
	*x=p->x-BULANEC_SIRKA/2;
	*y=p->y-BULANEC_VYSKA/2;
	*w=BULANEC_SIRKA;
	*h=BULANEC_VYSKA;
}

void getRozmeryGrafika(bulanec *p,int *x,int *y,int *w,int *h)
{
	*x=(p->x-BULANEC_SIRKA/2)+((BULANEC_SIRKA-GRAFIKA_BULANEC_SIRKA)/2);
	*y=(p->y-BULANEC_VYSKA/2)+(BULANEC_VYSKA-GRAFIKA_BULANEC_VYSKA);
	*w=GRAFIKA_BULANEC_SIRKA;
	*h=GRAFIKA_BULANEC_VYSKA;
}

bulanec* newBulanec(int x,int y,int id)
{
	bulanec *new;
	int i;

	new = malloc(sizeof(bulanec));
	new->x=x;
	new->y=y;
	new->id=id;
	
	for(i=0;i<POCET_ZBRANI;i++)
		new->naboje[i]=0;

	new->naboje[PISTOL]=MAX_POCET_STRIEL;
	new->zbran=PISTOL;
	new->otoceny=VPRAVO;
	new->mozeStrielat=0;
	new->mrtvy=0;
	new->bonus=BONUS_NIC;
	new->casBonus=0;
	new->score=0;
	new->animaciaKrokov=0;
	new->nabijaSaZasobnik=0;
	new->mozePrehoditZbran=0;
	new->vidiet=0;
	new->jeAI=SOM_OVLADANY_CLOVEKOM;
	strcpy(new->meno,"no_name");

	return new;
}

void destroyBulanec(bulanec *s)
{
	free(s);
}

void quitBulanec()
{
	int i;

	for(i=0;i<POCET_FARIEB_BULANCOV;i++)
	{
		SDL_FreeSurface(g_bulanec8[i]);
		SDL_FreeSurface(g_bulanec6[i]);
		SDL_FreeSurface(g_bulanec4[i]);
		SDL_FreeSurface(g_bulanec2[i]);
	}

	SDL_FreeSurface(g_kriz);
}
