
#include "interface.h"
#include "nastaveniaSiete.h"
#include "bulanec.h"
#include "hraSa.h"
#include "siet.h"
#include "chat.h"

static SDL_Color farba_pisma = {255,255,255,0};// Barva textu

static char riadky[CHAT_POCET_RIADKOV][STR_SIZE];
static char riadok[STR_SIZE];

static int mozePisat;
static int blik;

static SDL_Surface *g_chat;

void initChat()
{
	int i;

	for(i=0;i<CHAT_POCET_RIADKOV;i++)
		strcpy(riadky[i],"");

	strcpy(riadok,"");
	mozePisat=0;
	blik=0;

	g_chat=loadImage(PATH_IMAGE "chat.png",0);
}

void kresliChat()
{
	SDL_Rect dst_rect;
	SDL_Surface *text;
	char str[STR_SIZE];
	int i;
	
	dst_rect.x = (WINDOW_SIZE_X/2-CHAT_SIZE_X/2)-10;
	dst_rect.y = (WINDOW_SIZE_Y/2-CHAT_SIZE_Y/2)-10;
	SDL_BlitSurface(g_chat, NULL,screen, &dst_rect);

	strcpy(str,riadok);
	if(blik<5)sprintf(str,"%s>",riadok);
	if(++blik==10)blik=0;

	text = TTF_RenderUTF8_Blended(g_font,str,farba_pisma);
		
	dst_rect.x = WINDOW_SIZE_X/2-CHAT_SIZE_X/2;
	dst_rect.y = WINDOW_SIZE_Y/2-CHAT_SIZE_Y/2+20*(CHAT_POCET_RIADKOV+1);
		
	SDL_BlitSurface(text,NULL,screen,&dst_rect);
	SDL_FreeSurface(text);

	for(i=0;i<CHAT_POCET_RIADKOV;i++)
	{
		text = TTF_RenderUTF8_Blended(g_font,riadky[i],farba_pisma);
		
		dst_rect.x = WINDOW_SIZE_X/2-CHAT_SIZE_X/2;
		dst_rect.y = WINDOW_SIZE_Y/2-CHAT_SIZE_Y/2+20*i;
		
		SDL_BlitSurface(text,NULL,screen,&dst_rect);
		SDL_FreeSurface(text);
	}

	pridajPrekresli(&zoznamPrekresli,
	(WINDOW_SIZE_X/2-CHAT_SIZE_X/2)-10,(WINDOW_SIZE_Y/2-CHAT_SIZE_Y/2)-10,
	CHAT_SIZE_X+20,CHAT_SIZE_Y+20);
}

void chatPridajRiadok(char *s)
{
	int i;

	for(i=0;i<CHAT_POCET_RIADKOV;i++)
		if(strcmp(riadky[i],"")==0)
		{
			strcpy(riadky[i],s);
			return;
		}

	for(i=1;i<CHAT_POCET_RIADKOV;i++)
		strcpy(riadky[i-1],riadky[i]);

	strcpy(riadky[CHAT_POCET_RIADKOV-1],s);
}

void akciaChat()
{
	int i;
	int len;
	Uint8 *mapa;
	char klavesa[2];
	
	mapa=SDL_GetKeyState(NULL);
	len=strlen(riadok);

	if(mozePisat>0)mozePisat--;

	if(mozePisat!=0)return;

	//mazanie posledneho klavesu
	if(mapa[SDLK_BACKSPACE]==SDL_PRESSED)
	{
		mozePisat=5;
		if(len>0)riadok[len-1]='\0';
		return;
	}

	if(mapa[SDLK_SPACE]==SDL_PRESSED)
	{
		mozePisat=5;
		strcat(riadok," ");
		return;
	}

	if(mapa[SDLK_KP_ENTER]==SDL_PRESSED || mapa[SDLK_RETURN]==SDL_PRESSED)
	{
		char celyRiadok[STR_SIZE];
		strcpy(celyRiadok,getbulanec(getTuxKtorehoOvladam())->meno);
		strcat(celyRiadok,": ");
		strcat(celyRiadok,riadok);

		chatPridajRiadok(celyRiadok);

#ifdef NET_MULTIPLAYER
		char str[STR_SIZE];
		int i;

		len=strlen(celyRiadok);
		for(i=0;i<len;i++)
			if(celyRiadok[i]==' ')celyRiadok[i]='_';

		sprintf(str,"chat %s",celyRiadok);

		if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
		if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
#endif

		mozePisat=5;
		strcpy(riadok,"");
		return;
	}

	//klavesy abecedy
	for(i=SDLK_a;i<=SDLK_z;i++)
	{
		if(mapa[i]==SDL_PRESSED)
		{
			mozePisat=5;
			strcat(riadok,SDL_GetKeyName(i));
			
			if(mapa[SDLK_LSHIFT]==SDL_PRESSED ||
			   mapa[SDLK_RSHIFT]==SDL_PRESSED)
			{
				riadok[strlen(riadok)-1]-=32;
			}
		}
	}

	// aby ve jmene bulanka fungovaly take cislice alfanumericke klavesnice
	for(i=SDLK_0;i<=SDLK_9;i++)
	{
		if(mapa[i]==SDL_PRESSED)
		{
			mozePisat=5;
			strcat(riadok, SDL_GetKeyName(i));
		}
	}
	
	// aby ve jmene bulanka fungovaly take cislice napsane na numericke klavesnici
	for(i=SDLK_KP0;i<=SDLK_KP9;i++)
	{
		if(mapa[i]==SDL_PRESSED)
		{
			mozePisat=5;
			sprintf(klavesa, "%d", i-256);
			strcat(riadok, klavesa);
		}
	}
}

void quitChat()
{
	SDL_FreeSurface(g_chat);
}

