
#include "interface.h"
#include "keytable.h"
#include "zbrane.h"
#include "bulanec.h"
#include "panel.h"
#include "strela.h"
#include "prekazka.h"
#include "vec.h"
#include "animacia.h"
#include "robot.h"
#include "teleport.h"
#include "trubky.h"
#include "nastavenia.h"
#include "nastaveniaSiete.h"
#include "tabulka.h"
#include "hudba.h"
#include "zvuky.h"
#include "jazyk.h"
#include "ai.h"
#include "hraSa.h"
#include "suborLevel.h"
#include "vyhodnotenie.h"
#include "chat.h"

#ifdef NET_MULTIPLAYER
#include "siet.h"
#endif

//pozadie
static SDL_Surface *g_bg;

static SDL_Surface *g_pauza;

SDL_Surface **veciSurface;

static int kolo;
static int pauza;
static int casPauza;
static int casovacKoniec;
static int tux_ktoreho_ovladam;

void initHraSa()
{	
	//Potrebuju ID kazde veci, ktera se bude pouzivat! Po siti se nedaji posilat pointery 
	//(resp. daji, ale je to k nicemu), takze musi mit vsechno cislo, nebo textove vyjadreni,..
	
	veciSurface = malloc(POCET_VECI * sizeof (void *));
	memset(veciSurface,0,POCET_VECI * sizeof (void *));

	veciSurface[PISTOL_DUAL] = loadImage(PATH_IMAGE "anim.ikonka.pistole-dual.png",1);
	veciSurface[BROKOVNICA] = loadImage(PATH_IMAGE "anim.ikonka.brokovnica.png",1);
	veciSurface[SAMOPAL] = loadImage(PATH_IMAGE "anim.ikonka.samopal.png",1);
	veciSurface[LASSER] = loadImage(PATH_IMAGE "anim.ikonka.lasergun.png",1);
	veciSurface[BOMBA] = loadImage(PATH_IMAGE "anim.ikonka.bomba.png",1);
	veciSurface[BOMB_BALL] = loadImage(PATH_IMAGE "anim.ikonka.bomb-ball.png",1);
	veciSurface[MINA] = loadImage(PATH_IMAGE "mina.png",1);

	veciSurface[BONUS_RYCHLOST] = loadImage(PATH_IMAGE "anim.bonus_rychlost.png",1);
	veciSurface[BONUS_NABOJE] = loadImage(PATH_IMAGE "anim.bonus_naboje.png",1);
	veciSurface[BONUS_4X] = loadImage(PATH_IMAGE "anim.bonus_4x.png",1);
	veciSurface[BONUS_TELEPORT] = loadImage(PATH_IMAGE "anim.bonus_teleport.png",1);
	veciSurface[BONUS_DUCH] = loadImage(PATH_IMAGE "anim.bonus_duch.png",1);
	veciSurface[BONUS_NEVYDITELNY] = loadImage(PATH_IMAGE "anim.bonus_nevyditelny.png",1);

	veciSurface[VYBUCH] = loadImage(PATH_IMAGE "vybuch.png",1);
	veciSurface[MAX_VYBUCH] = loadImage(PATH_IMAGE "max-vybuch.png",1);

	switch(getJazyk())
	{
		case JAZYK_SK :
		case JAZYK_CZ :
			g_pauza = loadImage(PATH_IMAGE "pauza.sk-cz.png",1);
		break;
		default :
			g_pauza = loadImage(PATH_IMAGE "pauza.en.png",1);
		break;
	}
}

void setSmer(int smer,int *px,int *py)
{
	switch(smer)
	{
		case HORE:
			*px=0;
			*py=-1;
		break;
		case VPRAVO:
			*px=+1;
			*py=0;
		break;
		case VLAVO:
			*px=-1;
			*py=0;
		break;
		case DOLE:
			*px=0;
			*py=+1;
		break;
	}
}

int negujSmer(int n)
{
	switch(n)
	{
		case HORE:
			return DOLE;
		break;
		case VPRAVO:
			return VLAVO;
		break;
		case VLAVO:
			return VPRAVO;
		break;
		case DOLE:
			return HORE;
		break;
	}

	return -1;
}

int koliziaObdlznikov(int x1,int y1,int w1,int h1,int x2,int y2,int w2,int h2)
{
	return (x1<x2+w2 && x2<x1+w1 && y1<y2+h2 && y2<y1+h1);
}

void prehod(int *a,int *b)
{
	int z;

	z=*a;
	*a=*b;
	*b=z;
}

void zvysKolo()
{
	kolo++;

#ifdef NET_MULTIPLAYER
	if(getNastaveniaSieteStav()!=NONE)
	{
		char str[STR_SIZE];
		sprintf(str,"kolo %d",kolo);
		if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
		if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
	}
#endif

}

void setKolo(int n)
{
	kolo=n;
}

int getTuxKtorehoOvladam()
{
	return tux_ktoreho_ovladam;
}

void zapniVypniPauzu()
{
//	int i;

	if(pauza)
		pauza=0;
	else
		pauza=1;

	casPauza=CAS_NEMOZE_SPUSTIT_PAUZU;
/*
	printf("pauza=%d\n",pauza);
	puts("------");

	for(i=0;armadaBulancov[i]!=NULL;i++)
	{
		printf("id=%d %s (%d)\n",
		armadaBulancov[i]->id,
		armadaBulancov[i]->meno,
		armadaBulancov[i]->score);
	}
*/

	pridajPrekresli(&zoznamPrekresli,
	(WINDOW_SIZE_X/2-CHAT_SIZE_X/2)-10,(WINDOW_SIZE_Y/2-CHAT_SIZE_Y/2)-10,
	CHAT_SIZE_X+20,CHAT_SIZE_Y+20);
}

void kresliHraSa()
{
	SDL_Rect dst_rect;
	int i;

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(g_bg, NULL,screen, &dst_rect);
	
	for(i=0;armadaBulancov[i]!=NULL;i++)
		kresliBulanec(armadaBulancov[i]);

	kresliVec(&zoznamVeci);
	kresliTeleport(&zoznamTeleport);
	kresliTrubka(&zoznamTrubka);
	kresliStrela(&zoznamStrel);
	kresliPrekazka(&zoznamPrekazok);
	kresliAnimacia(&zoznamAnimacia);
	kresliRobot(&zoznamRobot);

	zoznamImageShow(&zoznamImage);

	if(pauza)
	{
		if(getNastaveniaSieteStav()==NONE)
		{
			dst_rect.x = WINDOW_SIZE_X/2-PAUZA_SIZE_X/2;
			dst_rect.y = WINDOW_SIZE_Y/2-PAUZA_SIZE_Y/2;
			SDL_BlitSurface(g_pauza, NULL,screen, &dst_rect);
		}
		else
		{
			kresliChat();
		}
	}

	pridajPrekresli(&zoznamPrekresli,WINDOW_SIZE_X/2-PAUZA_SIZE_X/2,
	WINDOW_SIZE_Y/2-PAUZA_SIZE_Y/2,PAUZA_SIZE_X,PAUZA_SIZE_Y);

	if(getNastaveniaSieteStav()==NONE)
		kresliPanel(armadaBulancov[ACTIVE_BULANEC1],armadaBulancov[ACTIVE_BULANEC2]);
	else
		kresliPanel(armadaBulancov[tux_ktoreho_ovladam],NULL);

}

void klavesaAkcia(bulanec *p,int s)
{
	int zal;
	int px,py;
	int mykrok;

	if(pauza || p->mrtvy!=0 || p->vidiet!=0)return;	
	
	if(s!=STREL && p->otoceny!=s)
	{
		int x,y,w,h;
		getRozmeryGrafika(p,&x,&y,&w,&h);

		zal=p->otoceny;
		p->otoceny=s;
	
		if(koliziaBulanecStena(p,0,0)==1 ||
		   koliziaBulanecAnimacia(p,0,0)==1 ||
		   koliziaBulanecRobot(p,0,0)==1 ||
		   koliziaBulanecTrubka(p,0,0)==1)
		{
			p->otoceny=zal;
		}
		
#ifdef NET_MULTIPLAYER
				if(getNastaveniaSieteStav()!=NONE)
				{
					char str[STR_SIZE];
					sprintf(str,"pohyb %d %d %d %d",
					p->id,p->x,p->y,p->otoceny);
					if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
					if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				}
#endif

		pridajPrekresli(&zoznamPrekresli,x,y,w,h);
		return;
	}

	switch(s)
	{
		case HORE :
		case VPRAVO :
		case VLAVO :
		case DOLE :
			setSmer(s,&px,&py);
			mykrok=(p->bonus==BONUS_RYCHLOST?KROK*2:KROK);

			if(koliziaBulanecStena(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulancov(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecRobot(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecAnimacia(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecTrubka(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecTeleport(p,px*mykrok,py*mykrok)==0)
			{
				pohybBulanec(p,s);

#ifdef NET_MULTIPLAYER
				if(getNastaveniaSieteStav()!=NONE)
				{
					char str[STR_SIZE];
					sprintf(str,"pohyb %d %d %d %d",
					p->id,p->x,p->y,p->otoceny);
					if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
					if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				}
#endif
			}
		break;

		case STREL :
#ifdef NET_MULTIPLAYER
				if(getNastaveniaSieteStav()!=NONE)
				{
					char str[STR_SIZE];
					sprintf(str,"strela %d",p->id);
					if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
					if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
				}
#endif

			strielbaBulanec(p);
		break;
	}
}

//Vystreli z bulankovy zbrane
void strielbaBulanec(bulanec *p)
{
	if(p->bonus==BONUS_DUCH && p->casBonus==0)return;
	if(casovacKoniec!=0)return;

        if(p->mozeStrielat==0 && p->naboje[p->zbran]>0)
        {
		int i;

		if(p->zbran!=BOMBA)
		{
			if(p->bonus==BONUS_4X)
			{
				int zal;
				zal=p->otoceny;

				p->otoceny=HORE;
				vypniZvukvPriStrielani();
				pridajStrela(&zoznamStrel,p,p->zbran);
				p->otoceny=VPRAVO;
				pridajStrela(&zoznamStrel,p,p->zbran);
				p->otoceny=VLAVO;
				pridajStrela(&zoznamStrel,p,p->zbran);
				zapniZvukvPriStrielani();
				p->otoceny=DOLE;
				pridajStrela(&zoznamStrel,p,p->zbran);

				p->otoceny=zal;
			}
			else
			{
				pridajStrela(&zoznamStrel,p,p->zbran);
			}

			if(p->bonus!=BONUS_NABOJE)p->naboje[p->zbran]--;

		}
		else
		{
			pridajMinu(p);
		}

		for(i=0;armadaBulancov[i]!=NULL;i++)
			koliziaStrelaBulanec(armadaBulancov[i]);

		if(p->zbran==BROKOVNICA)p->mozeStrielat=CAS_NEMOZE_STRIELAT_BRKOVNICA;
		else p->mozeStrielat=CAS_NEMOZE_STRIELAT_OSTATNE_ZBRANE;

		if(p->naboje[p->zbran]==0)prehodZbran(p);
/*
		for(i=0;i<ZBRANI_CELKEM;i++)
			printf("%d\n",p->naboje[i]);
*/
		if(p->naboje[PISTOL]==0 && p->naboje[SAMOPAL]==0 &&
		   p->naboje[BROKOVNICA]==0 && p->naboje[BOMBA]==0 &&  
		   p->naboje[LASSER]==0 && p->naboje[BOMB_BALL]==0)
		{
			p->zbran=PISTOL;
			p->nabijaSaZasobnik=CAS_NABYJA_SA_ZASOBNIK;
		}
	}
}

/* *************************************************************************** */

void klavesnica()
{
	Uint8 *mapa;
	mapa=SDL_GetKeyState(NULL);
	
	if(getNastaveniaSieteStav()==NONE)
	{

		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_HORE))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],HORE);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_VPRAVO))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],VPRAVO);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_VLAVO))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],VLAVO);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_DOLE))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],DOLE);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_STRIELAJ))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],STREL);

		if(armadaBulancov[ACTIVE_BULANEC1]->mozePrehoditZbran==0 && 
		   isStlacilKlaves(KLAVES_BULANEC_VPRAVO_ZMEN_ZBRAN))
		{
			prehodZbran(armadaBulancov[ACTIVE_BULANEC1]);
			armadaBulancov[ACTIVE_BULANEC1]->mozePrehoditZbran=CAS_NEMOZE_PREHODIT_ZBRAN;
		}

		if(armadaBulancov[ACTIVE_BULANEC2]!=NULL)
		{
			if(isStlacilKlaves(KLAVES_BULANEC_VLAVO_POHYB_HORE))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],HORE);
			if(isStlacilKlaves(KLAVES_BULANEC_VLAVO_POHYB_VPRAVO))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],VPRAVO);
			if(isStlacilKlaves(KLAVES_BULANEC_VLAVO_POHYB_VLAVO))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],VLAVO);
			if(isStlacilKlaves(KLAVES_BULANEC_VLAVO_POHYB_DOLE))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],DOLE);
			if(isStlacilKlaves(KLAVES_BULANEC_VLAVO_STRIELAJ))klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],STREL);
		
			if(armadaBulancov[ACTIVE_BULANEC2]->mozePrehoditZbran==0 && 
			  isStlacilKlaves(KLAVES_BULANEC_VLAVO_ZMEN_ZBRAN))
			{
				prehodZbran(armadaBulancov[ACTIVE_BULANEC2]);
				armadaBulancov[ACTIVE_BULANEC2]->mozePrehoditZbran=CAS_NEMOZE_PREHODIT_ZBRAN;
			}
		}
	}

	if(getNastaveniaSieteStav()!=NONE)
	{
		bulanec *p;
		p=getbulanec(tux_ktoreho_ovladam);

		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_HORE))klavesaAkcia(p,HORE);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_VPRAVO))klavesaAkcia(p,VPRAVO);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_VLAVO))klavesaAkcia(p,VLAVO);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_POHYB_DOLE))klavesaAkcia(p,DOLE);
		if(isStlacilKlaves(KLAVES_BULANEC_VPRAVO_STRIELAJ))klavesaAkcia(p,STREL);

		if(armadaBulancov[tux_ktoreho_ovladam]->mozePrehoditZbran==0 && 
		   isStlacilKlaves(KLAVES_BULANEC_VPRAVO_ZMEN_ZBRAN))
		{
			prehodZbran(armadaBulancov[tux_ktoreho_ovladam]);
			armadaBulancov[tux_ktoreho_ovladam]->mozePrehoditZbran=CAS_NEMOZE_PREHODIT_ZBRAN;
		}
	}

	if(casPauza==0 && mapa[SDLK_p]==SDL_PRESSED)
	{
		zapniVypniPauzu();

#ifdef NET_MULTIPLAYER		
		if(getNastaveniaSieteStav()!=NONE)
		{
			char str[STR_SIZE];
			sprintf(str,"pauza %d",pauza);
			if(getNastaveniaSieteStav()==SERVER)odosliOstatnymClientom(str,VSETCI_CLIENTI);
			if(getNastaveniaSieteStav()==CLIENT)odosliServeru(str);
		}
#endif
	}
}

void akciaHraSa()
{
	int i,j;

	klavesnica();

	if(!pauza)
	{

		for(i=0;armadaBulancov[i]!=NULL;i++)
		{
			if(armadaBulancov[i]->jeAI==SOM_AI)akciaAI(armadaBulancov[i]);
			akciaBulanec(armadaBulancov[i]);
		}

		for(i=0;i<2;i++)
		{
			akciaStrela(&zoznamStrel);
			
			for(j=0;armadaBulancov[j]!=NULL;j++)
			{
				if(casovacKoniec==0)
				{
					koliziaStrelaBulanec(armadaBulancov[j]);
				}
			}

			koliziaStrelaBombBall();
			koliziaStrelaTrubka();
			koliziaStrelaAnimacia();
			koliziaStrelaRobot();
			koliziaStrelaStena();
			koliziaStrelaTeleport();
			koliziaStrelaVec();
		}

		akciaAnimacia(&zoznamAnimacia);
		akciaRobot(&zoznamRobot);
		akciaVec(&zoznamVeci);
	}

	if(casPauza>0)casPauza--;

	if(pauza)
	{
		if(getNastaveniaSieteStav()!=NONE)akciaChat();
	}

	if(getNastaveniaSieteStav()==NONE && kolo>=getNastaveniaPocetKol())
	{
		if(casovacKoniec==0)
		{
			skonciHudbu();
			prehrajZvuk(ZVUK_OPENING);
		}

		casovacKoniec++;
	}

	if(getNastaveniaSieteStav()!=NONE && kolo>=getPocetkolVSietach())
	{
		if(casovacKoniec==0)
		{
			skonciHudbu();
			prehrajZvuk(ZVUK_OPENING);
		}

		casovacKoniec++;
	}

	if(getNastaveniaSieteStav()!=NONE && getKoniecSiete())casovacKoniec=CASOVAC_KONIEC_MAX;

	if(casovacKoniec>=CASOVAC_KONIEC_MAX)quitLevel();
}

int isVolnyPriestor(int x,int y,int w,int h)
{
	int i;
	int xine,yine,wine,hine;

	prekazka *terazPrekazka;
	vec *terazVec;
	animacia *terazAnimacia;
	robot *terazRobot;
	teleport *terazTeleport;
	trubka *terazTrubka;
	
	for(i=0;armadaBulancov[i]!=NULL;i++)
	{
		getRozmery(armadaBulancov[i],&xine,&yine,&wine,&hine);

		if (armadaBulancov[i]->x!=SURADNICA_ZIADNA && 
		koliziaObdlznikov(x-10,y-10,w+20,h+20,xine,yine,wine,hine))return 0;
	}

	terazPrekazka=zoznamPrekazok;
	
	while(terazPrekazka!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazPrekazka->x,terazPrekazka->y,terazPrekazka->w,terazPrekazka->h))return 0;
	
		terazPrekazka=terazPrekazka->next;
	}

	terazVec=zoznamVeci;
	
	while(terazVec!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazVec->x,terazVec->y,terazVec->w,terazVec->h))return 0;
	
		terazVec=terazVec->next;
	}

	terazAnimacia=zoznamAnimacia;
	
	while(terazAnimacia!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		   terazAnimacia->x,terazAnimacia->y,terazAnimacia->w,terazAnimacia->h))return 0;

		terazAnimacia=terazAnimacia->next;
	}

	terazRobot=zoznamRobot;
	
	while(terazRobot!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		   terazRobot->x,terazRobot->y,terazRobot->w,terazRobot->h))return 0;

		terazRobot=terazRobot->next;
	}

	terazTeleport=zoznamTeleport;
	
	while(terazTeleport!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazTeleport->x,terazTeleport->y,terazTeleport->w,terazTeleport->h))return 0;

		terazTeleport=terazTeleport->next;
	}

	terazTrubka=zoznamTrubka;
	
	while(terazTrubka!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazTrubka->x,terazTrubka->y,terazTrubka->w,terazTrubka->h))return 0;

		terazTrubka=terazTrubka->next;
	}

	return 1;
}

void volnyPriestor(int *x,int *y,int w,int h)
{
	int nx,ny;

	nx=*x;
	ny=*y;

	do{
		nx=rand()%(HRACIA_PLOCHA_SIZE_X-w);
		ny=rand()%(HRACIA_PLOCHA_SIZE_Y-(PANEL_SIZE_Y+h));
	}while(isVolnyPriestor(nx,ny,w,h)==0);

	*x=nx;
	*y=ny;
}

void pridajZbran()
{
	int x,y,w,h;
	int co=0;
	int coPridam=NONE;

	w=VEC_ZBRAN_SIZE_X;
	h=VEC_ZBRAN_SIZE_X;

	volnyPriestor(&x,&y,w,h);
	//pridajVec(&zoznamVeci,x,y,BONUS_RYCHLOST);

	if(isPovolenaNejakaZbran())coPridam=ZBRAN;
	
	if(isPovolenyNejakyBonus())
	{
		if(coPridam==NONE)coPridam=BONUS;
		else coPridam=(rand()%5==0?BONUS:ZBRAN);
	}

	if(coPridam==ZBRAN)
	{
		do{
			switch(rand()%6+1)
			{
				case 1 : co=PISTOL_DUAL; break;
				case 2 : co=BROKOVNICA; break;
				case 3 : co=SAMOPAL; break;
				case 4 : co=LASSER; break;
				case 5 : co=BOMB_BALL; break;
				case 6 : co=BOMBA; break;
			}
		}while(getNastavenia(co)==0);
	}

	if(coPridam==BONUS)
	{
		do{
			switch(rand()%6+1)
			{
				case 1 : co=BONUS_RYCHLOST; break;
				case 2 : co=BONUS_NABOJE; break;
				case 3 : co=BONUS_4X; break;
				case 4 : co=BONUS_TELEPORT; break;
				case 5 : co=BONUS_DUCH; break;
				case 6 : co=BONUS_NEVYDITELNY; break;
			}
		}while(getNastavenia(co)==0);
	}

	if(getNastaveniaSieteStav()==NONE)
	{
		pridajVec(&zoznamVeci,x,y,co,NULL);
	}

#ifdef NET_MULTIPLAYER
	if (getNastaveniaSieteStav()==SERVER)
	{
		char str[STR_SIZE];
		sprintf(str,"vec %d %d %d",x,y,co);
		odosliOstatnymClientom(str,VSETCI_CLIENTI);
		pridajVec(&zoznamVeci,x,y,co,NULL);
	}
#endif

}

void pridajMinu(bulanec *p)
{
	int x,y;
	int w,h;
	int zalx,zaly;

	w=MINA_SIZE_X;
	h=MINA_SIZE_Y;
	x=p->x;
	y=p->y;

	switch(p->otoceny)
	{
		case HORE:
			y+=4+MINA_SIZE_Y;
		break;
		case VPRAVO:
			x-=20+MINA_SIZE_X;
		break;
		case VLAVO:
			x+=4+MINA_SIZE_X;
		break;
		case DOLE:
			y-=20+MINA_SIZE_Y;
		break;
	}

	zalx=p->x;
	zaly=p->y;
	p->x=SURADNICA_ZIADNA;
	p->y=SURADNICA_ZIADNA;

	if(isVolnyPriestor(x,y,w,h))
	{
		pridajVec(&zoznamVeci,x,y,MINA,p);
		pridajPrekresli(&zoznamPrekresli,x-10,y-10,w+20,h+20);
		p->naboje[BOMBA]--;
	}

	p->x=zalx;
	p->y=zaly;
}

/* *************************************************************************** */

void vytvorBulancov(int pocet,int n)
{
	int i;

	armadaBulancov = malloc((pocet+1)*sizeof(bulanec*));
	memset(armadaBulancov,0,(pocet+1)*sizeof(bulanec*));

	for(i=0;i<pocet;i++)
	{
		armadaBulancov[i]=newBulanec(0,0,i);
		
		if(getNastaveniaSieteStav()==SERVER || getNastaveniaSieteStav()==NONE)
		{
			volnyPriestor(&armadaBulancov[i]->x,&armadaBulancov[i]->y,
			BULANEC_SIRKA,BULANEC_VYSKA);

			armadaBulancov[i]->x+=BULANEC_SIRKA/2;
			armadaBulancov[i]->y+=BULANEC_VYSKA/2;
		}
	}

	if(getNastaveniaSieteStav()==NONE && getNastaveniaAI())
	{
		armadaBulancov[ACTIVE_BULANEC2]->jeAI=SOM_AI;
		initAI();
	}

	if(getNastaveniaSieteStav()!=NONE)
	{
		tux_ktoreho_ovladam=n;
		getMena(getbulanec(tux_ktoreho_ovladam)->meno,NULL);
	}
	else
	{
		getMena(armadaBulancov[ACTIVE_BULANEC1]->meno,
		armadaBulancov[ACTIVE_BULANEC2]->meno);
	}
}

void odstranBulancov()
{
	destroyBulanec(armadaBulancov[ACTIVE_BULANEC1]);
	if(armadaBulancov[ACTIVE_BULANEC2]!=NULL)destroyBulanec(armadaBulancov[ACTIVE_BULANEC2]);
	free(armadaBulancov);
	armadaBulancov=NULL;
}

/* *************************************************************************** */

void nacitajLevel(char **riadky)
{
	char *line;
	char cmd[STR_SIZE];
	char s_file[STR_SIZE];
	int a,b,c,d,e,f,g,h,i,j,k;
	int cisloRiadka;

	kolo=0;
	pauza=0;
	casPauza=0;
	casovacKoniec=0;

	initStrela();
	initPrekazka();
	initVec();
	initAnimacia();
	initRobot();
	initTeleport();
	initTrubka();
	initChat();

	for(cisloRiadka=0;riadky[cisloRiadka]!=NULL;cisloRiadka++)
	{
		line=(char *)riadky[cisloRiadka];

		if(strncmp(line,PRIKAZ_SETPLOCHA,PRIKAZ_SETPLOCHA_DLZKA)==0)
		{
			sscanf(line,"%s %s",cmd,s_file);			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			g_bg = loadImage(str,0);

			free(str);

			continue;
		}

		if(strncmp(line,PRIKAZ_ADD,PRIKAZ_ADD_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %d %d %s",
			       cmd,&a,&b,&c,&d,&f,&g,&h,&i,&j,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajPrekazku(&zoznamPrekazok,a,b,c,d,f,g,h,i,j,str);

			free(str);

			continue;
		}

		if(strncmp(line,PRIKAZ_ANIMACIA,PRIKAZ_ANIMACIA_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,&e,&f,&g,&h,&i,&j,&k,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajAnimacia(&zoznamAnimacia,a,b,c,d,loadImage(str,0),e,f,g,h,i,j,k);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_ROBOT,PRIKAZ_ROBOT_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,&e,&f,&g,&h,&i,&j,&k,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajRobot(&zoznamRobot,a,b,c,d,loadImage(str,0),e,f,g,h,i,j,k);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_TELEPORT,PRIKAZ_TELEPORT_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajTeleport(&zoznamTeleport,a,b,c,d,str);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_TRUBKA,PRIKAZ_TRUBKA_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,&e,&f,&g,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajTrubka(&zoznamTrubka,a,b,c,d,e,f,g,str);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_SETMUSIC,PRIKAZ_SETMUSIC_DLZKA)==0)
		{
			sscanf(line,"%s %s",
			       cmd,s_file);
			
			unsigned strl1 = strlen(PATH_MUSIC);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_MUSIC,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			nacitajVlastnuHudbu(str);
			free(str);
			continue;
		}
	}

	prehrajHudbu(HUDBA_VLASTNA);
}

void quitLevel()
{
	char meno1[STR_SIZE];
	char meno2[STR_SIZE];
	int co=NEBOL_ZAPIS_DO_TABULKY;

	if(getNastaveniaSieteStav()==NONE)
	{

		getMena(meno1,meno2);

		nacitajTabulku();

		if(armadaBulancov[ACTIVE_BULANEC1]->score>
		   armadaBulancov[ACTIVE_BULANEC2]->score)
		{
			co=vlozDoTabulky(armadaBulancov[ACTIVE_BULANEC1]->meno,
			armadaBulancov[ACTIVE_BULANEC1]->score);
		}

		if(armadaBulancov[ACTIVE_BULANEC2]->score>
		   armadaBulancov[ACTIVE_BULANEC1]->score)
		{
			if(armadaBulancov[ACTIVE_BULANEC2]->jeAI==SOM_AI)
				co=vlozDoTabulky(AI_NAME,armadaBulancov[ACTIVE_BULANEC2]->score);
			else
			{
				co=vlozDoTabulky(armadaBulancov[ACTIVE_BULANEC2]->meno,
				armadaBulancov[ACTIVE_BULANEC2]->score);
			}
		}
	
		ulozTabulku();

		setMiesto_v_hre((co==BOL_ZAPIS_DO_TABULKY?TABULKA:MAIN_MENU));
	}
	else
	{
#ifdef NET_MULTIPLAYER
		int i;

		rozpojSiet(NEODODSLI_SPRAVU);

		noveVyhodnotenie(getPocetBulancov());
		
		for(i=0;armadaBulancov[i]!=NULL;i++)
			pridajVyhodnotenie(armadaBulancov[i]->meno,armadaBulancov[i]->score);

		setMiesto_v_hre(VYHODNOTENIE);
#endif
	}
	
	odstranBulancov();

	quitStrela(&zoznamStrel);
	quitPrekazka(&zoznamPrekazok);
	quitVec(&zoznamVeci);
	quitAnimacia(&zoznamAnimacia);
	quitRobot(&zoznamRobot);
	quitTeleport(&zoznamTeleport);
	quitTrubka(&zoznamTrubka);
	quitChat();

	SDL_FreeSurface(g_bg);

	uvolniVlastnuHudbu();
}

void quitHraSa()
{
	int i;

	for (i=0;i<POCET_VECI;i++)
		if(veciSurface[i]!=NULL)SDL_FreeSurface(veciSurface[i]);
	
	free(veciSurface);
}
