
#include "interface.h"
#include "zbrane.h"
#include "ikonky.h"

static SDL_Surface *g_vec_pistol;

static SDL_Surface *g_vec_pistolDual;
static SDL_Surface *g_vec_brokovnica;
static SDL_Surface *g_vec_samopal;
static SDL_Surface *g_vec_lasser;
static SDL_Surface *g_vec_bombball;
static SDL_Surface *g_vec_bomba;
static SDL_Surface *g_vec_mina;

static SDL_Surface *g_vec_bonus_rychlost;
static SDL_Surface *g_vec_bonus_naboje;
static SDL_Surface *g_vec_bonus_4x;
static SDL_Surface *g_vec_bonus_teleport;
static SDL_Surface *g_vec_bonus_duch;
static SDL_Surface *g_vec_bonus_nevyditelny; 

static SDL_Surface *g_vec_cb_pistolDual;
static SDL_Surface *g_vec_cb_brokovnica;
static SDL_Surface *g_vec_cb_samopal;
static SDL_Surface *g_vec_cb_lasser;
static SDL_Surface *g_vec_cb_bombball;
static SDL_Surface *g_vec_cb_bomba;

static SDL_Surface *g_vec_cb_bonus_rychlost;
static SDL_Surface *g_vec_cb_bonus_naboje;
static SDL_Surface *g_vec_cb_bonus_4x;
static SDL_Surface *g_vec_cb_bonus_teleport;
static SDL_Surface *g_vec_cb_bonus_duch;
static SDL_Surface *g_vec_cb_bonus_nevyditelny; 

void initIkonky()
{
	g_vec_pistol=loadImage(PATH_IMAGE "ikonka.pistole.png",1);
	g_vec_pistolDual=loadImage(PATH_IMAGE "ikonka.pistole-dual.png",1);
	g_vec_samopal=loadImage(PATH_IMAGE "ikonka.samopal.png",1);
	g_vec_brokovnica=loadImage(PATH_IMAGE "ikonka.brokovnica.png",1);
	g_vec_lasser=loadImage(PATH_IMAGE "ikonka.lasergun.png",1);
	g_vec_bomba=loadImage(PATH_IMAGE "ikonka.bomba.png",1);
	g_vec_bombball=loadImage(PATH_IMAGE "ikonka.bomb-ball.png",1);
	g_vec_mina=loadImage(PATH_IMAGE "mina.png",1);

	g_vec_bonus_rychlost=loadImage(PATH_IMAGE "bonus_rychlost.png",1);
	g_vec_bonus_naboje=loadImage(PATH_IMAGE "bonus_naboje.png",1);
	g_vec_bonus_4x=loadImage(PATH_IMAGE "bonus_4x.png",1);
	g_vec_bonus_teleport=loadImage(PATH_IMAGE "bonus_teleport.png",1);
	g_vec_bonus_duch=loadImage(PATH_IMAGE "bonus_duch.png",1);
	g_vec_bonus_nevyditelny=loadImage(PATH_IMAGE "bonus_nevyditelny.png",1);

	g_vec_cb_pistolDual=loadImage(PATH_IMAGE "cb.ikonka.pistole-dual.png",1);
	g_vec_cb_samopal=loadImage(PATH_IMAGE "cb.ikonka.samopal.png",1);
	g_vec_cb_brokovnica=loadImage(PATH_IMAGE "cb.ikonka.brokovnica.png",1);
	g_vec_cb_lasser=loadImage(PATH_IMAGE "cb.ikonka.lasergun.png",1);
	g_vec_cb_bomba=loadImage(PATH_IMAGE "cb.ikonka.bomba.png",1);
	g_vec_cb_bombball=loadImage(PATH_IMAGE "cb.ikonka.bomb-ball.png",1);

	g_vec_cb_bonus_rychlost=loadImage(PATH_IMAGE "cb.bonus_rychlost.png",1);
	g_vec_cb_bonus_naboje=loadImage(PATH_IMAGE "cb.bonus_naboje.png",1);
	g_vec_cb_bonus_4x=loadImage(PATH_IMAGE "cb.bonus_4x.png",1);
	g_vec_cb_bonus_teleport=loadImage(PATH_IMAGE "cb.bonus_teleport.png",1);
	g_vec_cb_bonus_duch=loadImage(PATH_IMAGE "cb.bonus_duch.png",1);
	g_vec_cb_bonus_nevyditelny=loadImage(PATH_IMAGE "cb.bonus_nevyditelny.png",1);
}

SDL_Surface* getIkonkaZbran(int x)
{
	switch(x)
	{
		case PISTOL : return g_vec_pistol; break;
		case PISTOL_DUAL : return g_vec_pistolDual; break;
		case BROKOVNICA : return g_vec_brokovnica; break;
		case SAMOPAL : return g_vec_samopal; break;
		case LASSER : return g_vec_lasser; break;
		case BOMB_BALL : return g_vec_bombball; break;
		case BOMBA : return g_vec_bomba; break;
	}

	return NULL;
}

SDL_Surface* getIkonkaCbZbran(int x)
{
	switch(x)
	{
		case PISTOL_DUAL : return g_vec_cb_pistolDual; break;
		case BROKOVNICA : return g_vec_cb_brokovnica; break;
		case SAMOPAL : return g_vec_cb_samopal; break;
		case LASSER : return g_vec_cb_lasser; break;
		case BOMB_BALL : return g_vec_cb_bombball; break;
		case BOMBA : return g_vec_cb_bomba; break;
	}

	return NULL;
}

SDL_Surface* getIkonkaBonus(int x)
{
	switch(x)
	{
		case BONUS_RYCHLOST : return g_vec_bonus_rychlost; break;
		case BONUS_NABOJE : return g_vec_bonus_naboje; break;
		case BONUS_4X : return g_vec_bonus_4x; break;
		case BONUS_TELEPORT : return g_vec_bonus_teleport; break;
		case BONUS_DUCH : return g_vec_bonus_duch; break;
		case BONUS_NEVYDITELNY : return g_vec_bonus_nevyditelny; break;
	}

	return NULL;
}

SDL_Surface* getIkonkaCbBonus(int x)
{
	switch(x)
	{
		case BONUS_RYCHLOST : return g_vec_cb_bonus_rychlost; break;
		case BONUS_NABOJE : return g_vec_cb_bonus_naboje; break;
		case BONUS_4X : return g_vec_cb_bonus_4x; break;
		case BONUS_TELEPORT : return g_vec_cb_bonus_teleport; break;
		case BONUS_DUCH : return g_vec_cb_bonus_duch; break;
		case BONUS_NEVYDITELNY : return g_vec_cb_bonus_nevyditelny; break;
	}

	return NULL;
}

void quitIkonky()
{
	SDL_FreeSurface(g_vec_samopal);
	SDL_FreeSurface(g_vec_brokovnica);
	SDL_FreeSurface(g_vec_bomba);
	SDL_FreeSurface(g_vec_mina);
	SDL_FreeSurface(g_vec_pistol);

	SDL_FreeSurface(g_vec_bonus_rychlost);
	SDL_FreeSurface(g_vec_bonus_naboje);
	SDL_FreeSurface(g_vec_bonus_4x);
	SDL_FreeSurface(g_vec_bonus_teleport);
	SDL_FreeSurface(g_vec_bonus_duch);
	SDL_FreeSurface(g_vec_bonus_nevyditelny);
}
