
#include "interface.h"
#include "jazyk.h"

static int statusJazyk;
static char strFont[STR_SIZE];
static int fontSize;

char* Text(int ID)
{
	return Jazyk.Databaze[ID];
}

int kodJazyk()
{
       	FILE* Soubor;
	char cesta[STR_SIZE];

        sprintf(cesta,"%s/language",getDomovskyAdresar());

	if (access(cesta, F_OK)!=0)
	{
		printf("Language config file %s not found, creating new one...\n", cesta);

		if ((Soubor = fopen(cesta, "wt")) == NULL)
		{
			fprintf(stderr, "Can't create the file, quitting!\n");
			exit(0);
		}

		fprintf(Soubor, "en\n");
		fclose(Soubor);
	}

      	if((Soubor = fopen(cesta, "rt")) == NULL)
      	{
       		fprintf(stderr,"Can't load language config file %s!\n", cesta);
       		exit(0);
       	}

	fscanf(Soubor,"%s", Jazyk.Kod);
	printf("Language: %s\n", Jazyk.Kod);
	fclose(Soubor);

	if(strstr(Jazyk.Kod,"sk"))statusJazyk=JAZYK_SK;
	if(strstr(Jazyk.Kod,"cz"))statusJazyk=JAZYK_CZ;
	if(strstr(Jazyk.Kod,"en"))statusJazyk=JAZYK_EN;
	if(strstr(Jazyk.Kod,"fr"))statusJazyk=JAZYK_FR;
	if(strstr(Jazyk.Kod,"ru"))statusJazyk=JAZYK_RU;

	return 0;
}

void initJazyk()
{
	kodJazyk();
	
 	FILE* Soubor;
	char cesta[STR_SIZE];
	char line[STR_SIZE];
	char prikaz[STR_SIZE];
	int veta;

	// Nacteni spravneho jazykoveho souboru
	sprintf(cesta,"%s%s.lang", PATH_LANG, Jazyk.Kod);
	strcpy(Jazyk.Cesta, cesta);

	if((Soubor = fopen(cesta,"rt")) == NULL)
	{
            	fprintf(stderr,"Language file \"%s\" not found!\n",cesta);
            	exit(0);
	}

	//nastavenie jazyka
	fgets(line,STR_SIZE-1,Soubor);
	sscanf(line,"%s %s %d",prikaz,strFont,&fontSize);

	// Cteni ze souboru
	for(veta = 0; veta < POCET_VET; veta++)
	{
		fgets(Jazyk.Databaze[veta],STR_SIZE-1,Soubor);
		Jazyk.Databaze[veta][strlen(Jazyk.Databaze[veta])-1]='\0';
	}

	// Zavření souboru
	fclose(Soubor);
}

int getJazyk()
{
	return statusJazyk;
}

char* getJazykStr()
{
	return Jazyk.Kod;
}

char *getJazykFont()
{
	return strFont;
}

int getJazykFontSize()
{
	return fontSize;
}

void tabulkaJazyk()
{
	printf(" ======== String table ======== \n\n");
	printf(" Language:      %s \n", Jazyk.Kod);
	printf(" Language file: %s \n", Jazyk.Cesta);	
	int veta;
	for(veta = 0; veta < POCET_VET; veta++)
	{
		printf("%d  -  %s\n",veta, Text(veta));	
	}
	printf(" ============================== \n");
}

