
#include "interface.h"
#include "suborLevel.h"
#include "zbrane.h"
#include "bulanec.h"
#include "panel.h"
#include "strela.h"
#include "prekazka.h"
#include "vec.h"
#include "animacia.h"
#include "robot.h"
#include "teleport.h"
#include "trubky.h"
#include "hraSa.h"
#include "nastaveniaSiete.h"
#include "siet.h"

#ifdef NET_MULTIPLAYER

#ifndef WIN32

#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#elif

#include <winsock.h>

#endif

static SDL_Thread *thread;
static SDL_mutex *mutex_network;

network_game game;

TCPsocket client_sock;
int failed_flag;

int processEvent(char *msg) {
	char event[16];
	int bulanec;
	char params[128];
	int i;
	int iparams[4];

	sscanf(msg,"%s ",(char *)&event);
	strcpy(params,(char*) ((int)msg+strlen(event)) );
SDL_LockMutex(mutex_display);
	if (strcmp(event,"quit")==0) {
		exit(1);
	} else if (strcmp(event,"setpos")==0) {
		sscanf(params,"%d %*s",&bulanec);
		lockBulanec(bulanec);
		sscanf(params+1,"%d %d %d %d", &bulanec, &armadaBulancov[bulanec]->x,&armadaBulancov[bulanec]->y,&armadaBulancov[bulanec]->otoceny);
		unlockBulanec(bulanec);
		fprintf(stderr,">> Bulanec %i set to %d %d %d\n", bulanec, armadaBulancov[bulanec]->x, armadaBulancov[bulanec]->y,
			armadaBulancov[bulanec]->otoceny);
		kresliBulanec(armadaBulancov[bulanec]);
	} else if (strcmp(event,"bmove")==0) {
		int smer;
		sscanf(params+1,"%d %d", &bulanec, &smer);
		pohybBulanec(armadaBulancov[bulanec], smer);
		kresliBulanec(armadaBulancov[bulanec]);
	} else if (strcmp(event,"bshoot")==0) {
		sscanf(params,"%i",&bulanec);
		strielbaBulanec(armadaBulancov[bulanec]);
	} else if (strcmp(event,"breset")==0 && getNastaveniaSieteStav() == CLIENT) {
		sscanf(params,"%i",&bulanec);
		lockBulanec(bulanec);
		for (i = 1; i < POCET_ZBRANI; i++)
			armadaBulancov[bulanec]->naboje[i] = 0;
		armadaBulancov[bulanec]->naboje[0] = MAX_POCET_STRIEL;
		armadaBulancov[bulanec]->zbran=PISTOL;
		armadaBulancov[bulanec]->mozeStrielat=0;
		armadaBulancov[bulanec]->mrtvy=0;
		pridajPrekresli(&zoznamPrekresli,armadaBulancov[bulanec]->x-20,armadaBulancov[bulanec]->y-20,KRIZ_SIZE_X+10,KRIZ_SIZE_Y+10);

		//Bude v rohu a nemel by se kreslit
		armadaBulancov[bulanec]->otoceny=-1;
		armadaBulancov[bulanec]->x = 0;
		armadaBulancov[bulanec]->y = 0;
		unlockBulanec(bulanec);
	} else if ((strcmp(event,"putitem") == 0) && getNastaveniaSieteStav() == CLIENT) {
		sscanf(params, "%d %d %d", &iparams[0], &iparams[1], &iparams[2]);
		pridajVec(&zoznamVeci, iparams[0], iparams[1], iparams[2]);
	} else if (strcmp(event,"dropitem") == 0) {
	} else if (strcmp(event,"start") == 0 && getNastaveniaSieteStav() == CLIENT) {
		odstranSpravu();
		setMiesto_v_hre(HRA_SA);
		sendEvent("started",(char *) NULL);
	} else if (strcmp(event,"started") == 0 && getNastaveniaSieteStav() == SERVER) {
		SDL_LockMutex(game.mutex);
		game.started = 1;
		SDL_UnlockMutex(game.mutex);
		printf(">> Game started\n");
	} else if (strcmp(event,"ready") == 0 && getNastaveniaSieteStav() == SERVER) {
		SDL_LockMutex(game.mutex);
		game.ready = 1;
		SDL_UnlockMutex(game.mutex);
		printf(">> Client ready\n");
	} else if (strcmp(event,"setlevel") == 0 && getNastaveniaSieteStav() == CLIENT) {
		SDL_LockMutex(game.mutex);
		sscanf(params,"%i",&game.level);
		printf(">> Level set to level %i\n", game.level);
		nacitajLevel((char **)zdrojakyLevelov[game.level-1]);
		SDL_UnlockMutex(game.mutex);
		printf(">> Level nacten\n");
		
		SDL_LockMutex(game.mutex);
		game.ready = 1;
		sendEvent("ready", (char *) NULL);
		SDL_UnlockMutex(game.mutex);

	}
SDL_UnlockMutex(mutex_display);
	return 0;
}

int netFailure(void) {
	fprintf(stderr, "Error: %s\n", SDLNet_GetError());
	return -1;
}

int runServer(void *nic)
{	
	IPaddress ip;
	TCPsocket server;

	Uint16 port;
	char sprava[STR_SIZE];


	if (SDLNet_Init()==-1) return netFailure();
	port = (Uint16) 2200;

	if (SDLNet_ResolveHost(&ip, NULL, port)) netFailure();

	server = SDLNet_TCP_Open(&ip);
	if (!server) netFailure();
	while(1) {
		client_sock = SDLNet_TCP_Accept(server);
		if(!client_sock) {
			SDL_Delay(100);
		} else { 
			SDL_LockMutex(game.mutex);
			game.clients++; 
			SDL_UnlockMutex(game.mutex);
			break; 
		}
	}

	while(1)
	{
		if(SDLNet_TCP_Recv(client_sock,sprava,STR_SIZE)<=0)
		{
			fprintf(stderr,"Connection broken!\n");
			break;
		}
#ifdef DEBUG
		fprintf(stderr,"** Received data: %s", sprava);
#endif
		if (strlen(sprava) <= 0) failed_flag++;
			else failed_flag = 0;
		if (failed_flag>15) exit(1);
		if (processEvent(sprava)<0) break;
	}
	return -1;
}

int runClient(void *nic)
{
	IPaddress ip;
	Uint16 port;
	
	char sprava[STR_SIZE];

	port = (Uint16) 2200;
 	if (SDLNet_ResolveHost(&ip, getIPAdresaServera(), port)==1) netFailure();

	int pokusy = 1;
	for (;;) {
		zobrazSpravu("Pripojuji se k serveru,...");
		pokusy++;
		SDL_LockMutex(mutex_network);
		client_sock = SDLNet_TCP_Open(&ip);
		if (client_sock) break;
		SDL_UnlockMutex(mutex_network);
		zobrazSpravu("Pripojeni se nezdarilo!\nDalsi pokus za 5s");
		SDL_Delay(5000);
	}

	zobrazSpravu("Cekam na server,..");

	for (;;)
	{
		if (SDLNet_TCP_Recv(client_sock,sprava,STR_SIZE) < 0)
		{
			fprintf(stderr,"Connection broken!\n");
			break;
		}
#ifdef DEBUG
		fprintf(stderr,"** Received data: %s", sprava);
#endif
		if (processEvent(sprava)<0) break;
	}

	return -1;
}

/*
 *  Send event to the server
 */
void sendEvent(char *event, char *parameters) {
	if (getNastaveniaSieteStav() == NONE) return;
	if (getNastaveniaSieteStav() == SERVER) {
		fprintf(stderr, "Checking for clients...");
		for (;;) {
			SDL_LockMutex(game.mutex);
			if ((game.clients+1) == (game.players)) {
				SDL_UnlockMutex(game.mutex);
				break;
			}
			SDL_UnlockMutex(game.mutex); 
			SDL_Delay(100); 
			continue;
		}
	} else {
		fprintf(stderr, "Checking for server connection...");
		for (;;) {
			SDL_LockMutex(mutex_network);
			if (client_sock) {
				SDL_UnlockMutex(mutex_network);
				break;
			}
			SDL_UnlockMutex(mutex_network);
			SDL_Delay(100);
		}
	} 

	fprintf(stderr, "ok\n");
	
	SDL_LockMutex(mutex_network);
	int retcode;
	int len = strlen(event) + 1;
	if (parameters!=NULL) len+=strlen(parameters) +2;
	char* buffer = malloc(sizeof(char) * len);
	buffer[0] = '\0';
	strcpy(buffer,event);
	if (parameters!=NULL) {
		strcat(buffer," ");
		strcat(buffer,parameters);
	}
#ifdef DEBUG
	printf("Sending event text: '%s'\n",buffer);
#endif
	strcat(buffer,"\n");
	retcode = SDLNet_TCP_Send(client_sock,buffer,sizeof(char) * len);
	free(buffer);
	if (retcode<((signed int)(sizeof(char) * len))) {
		fprintf(stderr,"Connection to server failed.\n");
		return;	//I will need to rewrite this function to report result
	}	
	else 
	{	
		//Wait for response?
	}
	
	SDL_UnlockMutex(mutex_network);
}

void initClientLink() {
	
}

void initServer()
{	
#ifdef DEBUG
	fprintf(stderr, "Initializing network (server)\n");
#endif
	mutex_network = SDL_CreateMutex();
	thread=SDL_CreateThread(runServer,NULL);

}

void initClient()
{
#ifdef DEBUG
	fprintf(stderr, "Initializing network (client)\n");
#endif
	mutex_network = SDL_CreateMutex();
	thread=SDL_CreateThread(runClient,NULL);
}

/*
 * Inicializace klientu
 * */

void initNetworkGame(int level) {
	game.mutex = SDL_CreateMutex();
	SDL_LockMutex(game.mutex);
	fprintf(stderr, "Initializing game structure\n");
	char *tmp = malloc(sizeof(char) * 32);
	sprintf(tmp,"%i",level);
	game.players = 2;
	game.started = 0;
	game.ready = 0;
	game.clients = 0;
	SDL_UnlockMutex(game.mutex);

	initServer();

	sendEvent("setlevel", tmp);
	for(;;) {
		SDL_LockMutex(game.mutex);
		if (game.ready == 1) {
			SDL_UnlockMutex(game.mutex);
			break;
		}
		SDL_UnlockMutex(game.mutex);
		SDL_Delay(100);
	}
	sendEvent("start", (char *) NULL);
	free(tmp);
}


#endif
