
#include "interface.h"
#include "zbrane.h"
#include "widget_label.h"
#include "widget_button.h"
#include "widget_check.h"
#include "widget_textfield.h"
#include "bulanec.h"
#include "kurzor.h"
#include "ikonky.h"
#include "jazyk.h"
#include "zvuky.h"
#include "hudba.h"
#include "nastaveniaSiete.h"
#include "nastavenia.h"
#include "mainMenu.h"

static SDL_Surface *g_ramcek;

static wid_button *cudlikOk;

static wid_check *cudlik[POCET_VECI];
static wid_check *cudlikZvuky;
static wid_check *cudlikHudba;
static wid_check *cudlikAI;

static wid_label *napisZbrane;
static wid_label *napisBonusy;
static wid_label *napisPocetKol;
static wid_label *napisHracVpravo;
static wid_label *napisHracVlavo;
static wid_label *napisZvuky;
static wid_label *napisHudba;
static wid_label *napisAI;

static wid_textfield *pocetKolPis;
static wid_textfield *meno1;
static wid_textfield *meno2;

static int defaultPocetKol=DEFAULT_POCET_KOL;
static char cesta[STR_SIZE];

void initNastavenia()
{
	int i;
	char textik[STR_SIZE];

	sprintf(cesta,"%s/" CONFIG_FILE,getDomovskyAdresar());

	g_ramcek = loadImage(PATH_IMAGE "ramecek.png",1);

	cudlikOk = newButton(WINDOW_SIZE_X/2+BUTTON_SIZE_X,WINDOW_SIZE_Y-75,"Ok");

	memset(cudlik,0,POCET_VECI*sizeof(wid_check *));

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA)
		{
			if(i<=PISTOL_DUAL+2)
			{
				cudlik[i]=newCheck(100-(CHECK_SIZE_X+10),100+50*i,CHECK_ANO);
			}
			else
			{
				cudlik[i]=newCheck(220-(CHECK_SIZE_X+10),100+50*(i-3),CHECK_ANO);
			}
		}

		if(i>=BONUS_RYCHLOST && i<=BONUS_NEVYDITELNY)
		{
			if(i<=BONUS_RYCHLOST+2)
			{
				cudlik[i]=newCheck((WINDOW_SIZE_X-200)-(CHECK_SIZE_X+10),
				100+50*(i-(BONUS_RYCHLOST-1)),CHECK_ANO);
			}
			else
			{
				cudlik[i]=newCheck((WINDOW_SIZE_X-100)-(CHECK_SIZE_X+10),
				100+50*((i-3)-(BONUS_RYCHLOST-1)),CHECK_ANO);
			}

			switch(i)
			{
				case BONUS_RYCHLOST :
					setCheckPopis(cudlik[i],POPIS_BONUSU_X,POPIS_BONUSU_Y,
					Text(TEXT_RYCHLA_CHODZA));
				break;
				case BONUS_NABOJE :
					setCheckPopis(cudlik[i],POPIS_BONUSU_X,POPIS_BONUSU_Y,
					Text(TEXT_NEKONECNO_NABOJOV));
				break;
				case BONUS_4X :
					setCheckPopis(cudlik[i],POPIS_BONUSU_X,POPIS_BONUSU_Y,
					Text(TEXT_STRELBA_DO_STYROCH_SMEROV));
				break;
				case BONUS_TELEPORT :
					setCheckPopis(cudlik[i],POPIS_BONUSU_X,POPIS_BONUSU_Y,
					Text(TEXT_TELEPORTACIA_TESNE_PRED_ZASAHOM_STRELI));
				break;
				case BONUS_DUCH :
					setCheckPopis(cudlik[i],POPIS_BONUSU_X,POPIS_BONUSU_Y,
					Text(TEXT_TUX_MOZE_PRECHADZAT_OBJEKTMI));
				break;
				case BONUS_NEVYDITELNY :
					setCheckPopis(cudlik[i],POPIS_BONUSU_X,POPIS_BONUSU_Y,
					Text(TEXT_OSTATNI_HRACI_TUXA_NEVIDIA));
				break;
			}
		}
	}

	napisZbrane = newLabel(100-(CHECK_SIZE_X+10),120,LABEL_LEFT,Text(TEXT_ZBRANE));
	napisBonusy = newLabel((WINDOW_SIZE_X-200)-(CHECK_SIZE_X+10),120,LABEL_LEFT,Text(TEXT_BONUSY));

	napisPocetKol = newLabel(100-(CHECK_SIZE_X+10),(WINDOW_SIZE_Y-190)+5,LABEL_LEFT,Text(TEXT_POCET_KOL));
	pocetKolPis = newTextfield(napisPocetKol->x+napisPocetKol->w+10,WINDOW_SIZE_Y-190,"15");

	napisHracVpravo = newLabel(100-(CHECK_SIZE_X+10),(WINDOW_SIZE_Y-148)+5,LABEL_LEFT,Text(TEXT_HRAC_VPRAVO));
	sprintf(textik, "%s%d",Text(TEXT_FIELD_HRAC), 1);
	meno1 = newTextfield(napisHracVpravo->x+napisHracVpravo->w+10,WINDOW_SIZE_Y-148,textik);
	napisHracVlavo = newLabel(100-(CHECK_SIZE_X+10),(WINDOW_SIZE_Y-106)+5,LABEL_LEFT,Text(TEXT_HRAC_VLAVO));
        sprintf(textik, "%s%d",Text(TEXT_FIELD_HRAC), 2);
	meno2 = newTextfield(napisHracVlavo->x+napisHracVlavo->w+10,WINDOW_SIZE_Y-106,textik);

	napisZvuky = newLabel(100-(CHECK_SIZE_X+10),(WINDOW_SIZE_Y-69)+5,LABEL_LEFT,Text(TEXT_HRAC_ZVUKY));
	cudlikZvuky = newCheck(napisZvuky->x+napisZvuky->w+10,WINDOW_SIZE_Y-69,CHECK_ANO);
	napisHudba = newLabel(cudlikZvuky->x+CHECK_SIZE_X+10,(WINDOW_SIZE_Y-69)+5,LABEL_LEFT,Text(TEXT_HRAC_HUDBA));
	cudlikHudba = newCheck(napisHudba->x+napisHudba->w+10,WINDOW_SIZE_Y-69,CHECK_ANO);
	napisAI = newLabel(cudlikHudba->x+CHECK_SIZE_X+10,(WINDOW_SIZE_Y-69)+5,LABEL_LEFT,"AI :"); //internacionalizmus
	cudlikAI = newCheck(napisAI->x+napisAI->w+10,WINDOW_SIZE_Y-69,CHECK_NIE);

	if(access(cesta,F_OK)!=0)
	{
		printf("vytvaram novy subor " CONFIG_FILE "\n");
		ulozNastavenia();
	}

	nacitajNastavenia();
}

void kresliNastavenia()
{
	SDL_Rect dst_rect;
	int i;

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(getTapeta(),NULL,screen, &dst_rect);
	
	dst_rect.x = POPIS_BONUSU_X-10;
	dst_rect.y = POPIS_BONUSU_Y-10;
	SDL_BlitSurface(g_ramcek,NULL,screen, &dst_rect);

	for(i=PISTOL_DUAL;i<=BOMBA;i++)
	{
		SDL_Surface *img;

		if(i<=PISTOL_DUAL+2)
		{
			dst_rect.x = 100;
			dst_rect.y = 105+i*50;
		}
		else
		{
			dst_rect.x = 220;
			dst_rect.y = 105+(i-3)*50;
		}

		img = (getNastaveniaSieteStav()!=CLIENT?getIkonkaZbran(i):getIkonkaCbZbran(i));
		SDL_BlitSurface(img,NULL,screen, &dst_rect);
	}

	for(i=BONUS_RYCHLOST;i<=BONUS_NEVYDITELNY;i++)
	{
		SDL_Surface *img;

		if(i<=BONUS_RYCHLOST+2)
		{
			dst_rect.x = WINDOW_SIZE_X-200;
			dst_rect.y = 100+50*(i-(BONUS_RYCHLOST-1));
		}
		else
		{
			dst_rect.x = WINDOW_SIZE_X-100;
			dst_rect.y = 100+50*((i-3)-(BONUS_RYCHLOST-1));
		}

		img = (getNastaveniaSieteStav()!=CLIENT?getIkonkaBonus(i):getIkonkaCbBonus(i));
		SDL_BlitSurface(img,NULL,screen, &dst_rect);
	}

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA)kresliCheck(cudlik[i]);
		if(i>=BONUS_RYCHLOST && i<=BONUS_NEVYDITELNY)kresliCheck(cudlik[i]);
	}

	kresliCheck(cudlikZvuky);
	kresliCheck(cudlikHudba);
	kresliCheck(cudlikAI);

	kresliLabel(napisZbrane);
	kresliLabel(napisBonusy);
	kresliLabel(napisPocetKol);
	kresliLabel(napisHracVpravo);
	kresliLabel(napisHracVlavo);
	kresliLabel(napisZvuky);
	kresliLabel(napisHudba);
	kresliLabel(napisAI);

	kresliTextfield(pocetKolPis);
	kresliTextfield(meno1);
	kresliTextfield(meno2);
	
	kresliButton(cudlikOk);

	kresliKurzor();

	pridajPrekresli(&zoznamPrekresli,0,0,WINDOW_SIZE_X,WINDOW_SIZE_Y);
}

void zmenNastavenia()
{
	defaultPocetKol=atoi(pocetKolPis->napis);
	if(defaultPocetKol==0)defaultPocetKol=15;
	setZvukyStatus(getStatus(cudlikZvuky));
	setHudbaStatus(getStatus(cudlikHudba));
}

void akciaNastavenia()
{
	int i;

	akciaButton();

	for(i=0;i<POCET_VECI;i++)
	{
		if(cudlik[i]!=NULL)
		{
			cudlik[i]->zapnuty=
			(getNastaveniaSieteStav()!=CLIENT?CHECK_ZAPNUTY:CHECK_VYPNUTY);
		}
	}

	napisZbrane->zapnuty=(getNastaveniaSieteStav()!=CLIENT?LABEL_ZAPNUTY:LABEL_VYPNUTY);
	napisBonusy->zapnuty=(getNastaveniaSieteStav()!=CLIENT?LABEL_ZAPNUTY:LABEL_VYPNUTY);
	napisPocetKol->zapnuty=(getNastaveniaSieteStav()!=CLIENT?LABEL_ZAPNUTY:LABEL_VYPNUTY);
	napisHracVlavo->zapnuty=(getNastaveniaSieteStav()!=CLIENT?LABEL_ZAPNUTY:LABEL_VYPNUTY);
	napisAI->zapnuty=(getNastaveniaSieteStav()==NONE?LABEL_ZAPNUTY:LABEL_VYPNUTY);
	cudlikAI->zapnuty=(getNastaveniaSieteStav()==NONE?CHECK_ZAPNUTY:CHECK_VYPNUTY);
	meno2->zapnuty=(getNastaveniaSieteStav()==NONE?TEXTFIELD_ZAPNUTY:TEXTFIELD_VYPNUTY);
	pocetKolPis->zapnuty=(getNastaveniaSieteStav()!=CLIENT?TEXTFIELD_ZAPNUTY:TEXTFIELD_VYPNUTY);

	akciaTextfield(pocetKolPis);
	akciaTextfield(meno1);

	akciaTextfield(meno2);

	if(isKlik(cudlikOk)==1)
	{
		zmenNastavenia();
		setMiesto_v_hre(MAIN_MENU);
	}

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA)akciaCheck(cudlik[i]);
		if(i>=BONUS_RYCHLOST && i<=BONUS_NEVYDITELNY)akciaCheck(cudlik[i]);
	}

	akciaCheck(cudlikZvuky);
	akciaCheck(cudlikHudba);
	akciaCheck(cudlikAI);

	if(isZmenilStav(cudlikHudba))
	{
		zmenNastavenia();
		if(getStatus(cudlikHudba))prehrajHudbu(HUDBA_HLAVNE_MENU);
	}
}

int getNastavenia(int n)
{
	return getStatus(cudlik[n]);
}

int getNastaveniaPocetKol()
{
	return defaultPocetKol;
}

int getNastaveniaAI()
{
	return getStatus(cudlikAI);
}

int isPovolenyNejakyBonus()
{
	int i;

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=BONUS_RYCHLOST && i<=BONUS_NEVYDITELNY && getNastavenia(i)==1)return 1;
	}

	return 0;
}

int isPovolenaNejakaZbran()
{
	int i;

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA && getNastavenia(i)==1)return 1;
	}

	return 0;
}

void getMena(char *s1,char *s2)
{
	if(s1!=NULL)strcpy(s1,meno1->napis);
	if(s2!=NULL)strcpy(s2,meno2->napis);
}

static void odstranMriez(char *s)
{
	int i;
	int len;

	len=strlen(s);

	for(i=0;i<len;i++)
		if(s[i]=='#')s[i]='\0'; // :)
}

void nacitajNastavenia()
{
	FILE *file;
	char line[STR_SIZE];
	char strPrikaz[STR_SIZE];
	char strVerzia[STR_SIZE];
	char str[STR_SIZE];
	int data=0,i;

	if((file = fopen(cesta,"rt"))==NULL)
	{
		fprintf(stderr,"subor %s sa neda otvorit pre citanie!\n",cesta);
		return;
	}
	
	fgets(line,STR_SIZE-1,file);
	sscanf(line,"%s %s",strPrikaz,strVerzia);

	if(strcmp(strPrikaz,CONFIG_LINE_VERSION)!=0 || strcmp(strVerzia,CURREN_VERSION_CONFIG_FILE)!=0)
	{
		printf("stara verzia suboru " CONFIG_FILE " vytvaram novu..\n");
		fclose(file);
		ulozNastavenia();
		nacitajNastavenia();
		return;
	}

	for(i=0;i<POCET_VECI;i++)
	{
		if(cudlik[i]!=NULL)
		{
			fgets(line,STR_SIZE-1,file);
			odstranMriez(line);
			sscanf(line,"%d",&cudlik[i]->status);
		}
	}

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%s",pocetKolPis->napis);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%s",meno1->napis);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%s",meno2->napis);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&cudlikZvuky->status);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&cudlikHudba->status);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&cudlikAI->status);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&data);
	setNastaveniaSieteStav(data);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%s",str);
	setIPAdresaServera(str);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&data);
	setPocetHracovKtoriSaPripoja(data);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&data);
	setSietovyPortServera(data);

	fclose(file);
}

void ulozNastavenia()
{
	FILE *file;
	char line[STR_SIZE];
	int i;

	if((file = fopen(cesta,"wt"))==NULL)
	{
		fprintf(stderr,"subor %s sa neda otvorit pre zapis!\n",cesta);
		return;
	}
	
	fprintf(file,"%s %s\n",CONFIG_LINE_VERSION,CURREN_VERSION_CONFIG_FILE);

	for(i=0;i<POCET_VECI;i++)
	{
		switch(i)
		{
			case PISTOL_DUAL : strcpy(line,"%d # mam pistol dual\n"); break;
			case BROKOVNICA : strcpy(line,"%d # mam brokovnicu\n"); break;
			case SAMOPAL : strcpy(line,"%d # mam samopal\n"); break;
			case LASSER : strcpy(line,"%d # mam lasser\n"); break;
			case BOMB_BALL : strcpy(line,"%d # mam bomb-ball\n"); break;
			case BOMBA : strcpy(line,"%d # mam miny\n"); break;
			case BONUS_RYCHLOST : strcpy(line,"%d # mam bonus rychlost\n"); break;
			case BONUS_NABOJE : strcpy(line,"%d # mam bonus naboje\n"); break;
			case BONUS_4X : strcpy(line,"%d # mam bonus 4X\n"); break;
			case BONUS_TELEPORT : strcpy(line,"%d # mam bonus teleport\n"); break;
			case BONUS_DUCH : strcpy(line,"%d # mam bonus duch\n"); break;
			case BONUS_NEVYDITELNY : strcpy(line,"%d # mam bonus nevyditelny\n"); break;
		}

		if(cudlik[i]!=NULL)fprintf(file,line,getStatus(cudlik[i]));
	}

	fprintf(file,"%s # pocet kol\n",pocetKolPis->napis);
	
	fprintf(file,"%s # meno tuxanca vpravo\n",meno1->napis);
	fprintf(file,"%s # meno tuxanca vlavo\n",meno2->napis);
	
	fprintf(file,"%d # zvuky\n",getStatus(cudlikZvuky));
	fprintf(file,"%d # hudba\n",getStatus(cudlikHudba));
	
	fprintf(file,"%d # AI\n",getStatus(cudlikAI));

	fprintf(file,"%d # stav -- none | client | server\n",getNastaveniaSieteStav());
	fprintf(file,"%s # IP adresa servera\n",getIPAdresaServera());
	fprintf(file,"%d # pocet hracov, ktory sa na server pripoja\n",getPocetHracovKtoriSaPripoja());
	fprintf(file,"%d # sietovy port servera\n",getSietovyPortServera());
	
	fclose(file);
}

void quitNastavenia()
{
	int i;

	ulozNastavenia();

	SDL_FreeSurface(g_ramcek);

	for(i=0;i<POCET_VECI;i++)
	{
		if(cudlik[i]!=NULL)destroyCheck(cudlik[i]);
	}

	destroyCheck(cudlikZvuky);
	destroyCheck(cudlikHudba);
	destroyCheck(cudlikAI);

	destroyLabel(napisZbrane);
	destroyLabel(napisBonusy);
	destroyLabel(napisPocetKol);
	destroyLabel(napisHracVpravo);
	destroyLabel(napisHracVlavo);
	destroyLabel(napisZvuky);
	destroyLabel(napisHudba);
	destroyLabel(napisAI);

	destroyTextfield(pocetKolPis);
	destroyTextfield(meno1);
	destroyTextfield(meno2);

	destroyButton(cudlikOk);
}
