
#include "interface.h"
#include "widget_label.h"
#include "widget_button.h"
#include "widget_check.h"
#include "widget_textfield.h"
#include "kurzor.h"
#include "jazyk.h"
#include "nastaveniaSiete.h"
#include "nastavenia.h"
#include "mainMenu.h"

static wid_button *cudlikDalej;
static wid_button *cudlikSpet;

static wid_label *napisStav;
static wid_label *napisNic;
static wid_label *napisServer;
static wid_label *napisClient;

static wid_label *napisNasClient;
static wid_label *napisNasServer;
static wid_label *napisNasPort;

static wid_check *cudlikNic;
static wid_check *cudlikServer;
static wid_check *cudlikClient;

static wid_textfield *pisServer;
static wid_textfield *pisClient;
static wid_textfield *pisPort;

static int stav;

void initNastaveniaSiete()
{
	stav=NONE;

	cudlikSpet = newButton(WINDOW_SIZE_X/2-BUTTON_SIZE_X,WINDOW_SIZE_Y-75,"Spet");
	cudlikDalej = newButton(WINDOW_SIZE_X/2+BUTTON_SIZE_X,WINDOW_SIZE_Y-75,"Dalej");

	napisStav = newLabel(100,120,LABEL_LEFT,Text(TEXT_STAV));

	cudlikNic = newCheck(100,napisStav->y+napisStav->h+10,CHECK_ANO);
	napisNic = newLabel(cudlikNic->x+CHECK_SIZE_X+10,napisStav->y+napisStav->h+10,LABEL_LEFT,Text(TEXT_NIC));

	cudlikServer = newCheck(100,cudlikNic->y+CHECK_SIZE_Y+10,CHECK_NIE);
	napisServer = newLabel(cudlikServer->x+CHECK_SIZE_X+10,cudlikNic->y+CHECK_SIZE_Y+10,LABEL_LEFT,Text(TEXT_SERVER));

	cudlikClient = newCheck(100,cudlikServer->y+CHECK_SIZE_Y+10,CHECK_NIE);
	napisClient = newLabel(cudlikClient->x+CHECK_SIZE_X+10,cudlikServer->y+CHECK_SIZE_Y+10,LABEL_LEFT,Text(TEXT_CLIENT));

	napisNasClient = newLabel(350,napisStav->y+napisStav->h+10,LABEL_LEFT,Text(TEXT_IP_ADRESA_SERVERA));
	napisNasServer = newLabel(350,napisStav->y+napisStav->h+10,LABEL_LEFT,Text(TEXT_POCET_HRACOV));

	pisServer = newTextfield(350,napisNasClient->y+napisNasClient->h+10,NASTAVENIA_SIETE_DEFAULT_POCET_HRACOV);
	pisClient = newTextfield(350,napisNasServer->y+napisNasServer->h+10,NASTAVENIA_SIETE_DEFAULT_IP_ADRESA_SERVERA);

	napisNasPort = newLabel(350,pisClient->y+TEXTFIELD_SIZE_Y+50,LABEL_LEFT,Text(TEXT_SIETOVY_PORT));
	pisPort = newTextfield(350,napisNasPort->y+napisNasPort->h+10,NASTAVENIA_SIETE_DEFAULT_PORT);
}

void kresliNastaveniaSiete()
{
	SDL_Rect dst_rect;

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(getTapeta(),NULL,screen, &dst_rect);
	
	kresliLabel(napisStav);
	kresliLabel(napisNic);
	kresliLabel(napisClient);
	kresliLabel(napisServer);

	kresliCheck(cudlikNic);
	kresliCheck(cudlikServer);
	kresliCheck(cudlikClient);

	if(getStatus(cudlikClient)==CHECK_ANO)
	{
		kresliLabel(napisNasClient);
		kresliTextfield(pisClient);
		kresliLabel(napisNasPort);
		kresliTextfield(pisPort);
	}

	if(getStatus(cudlikServer)==CHECK_ANO)
	{
		kresliLabel(napisNasServer);
		kresliTextfield(pisServer);
		kresliLabel(napisNasPort);
		kresliTextfield(pisPort);
	}

	kresliButton(cudlikSpet);
	kresliButton(cudlikDalej);

	kresliKurzor();

	pridajPrekresli(&zoznamPrekresli,0,0,WINDOW_SIZE_X,WINDOW_SIZE_Y);
}

void zmenNastaveniaSiete()
{
}

int getNastaveniaSieteStav()
{
	return stav;
}

void setNastaveniaSieteStav(int n)
{
	stav=n;

	cudlikNic->status=CHECK_NIE;
	cudlikServer->status=CHECK_NIE;
	cudlikClient->status=CHECK_NIE;

	switch(stav)
	{
		case NONE : cudlikNic->status=CHECK_ANO; break;
		case CLIENT : cudlikClient->status=CHECK_ANO; break;
		case SERVER : cudlikServer->status=CHECK_ANO; break;
	}
}

char* getIPAdresaServera()
{
	return pisClient->napis;
}

void setIPAdresaServera(char *s)
{
	strcpy(pisClient->napis,s);
}

int getPocetHracovKtoriSaPripoja()
{
	return atoi(pisServer->napis);
}

void setPocetHracovKtoriSaPripoja(int n)
{
	sprintf(pisServer->napis,"%d",n);
}

int getSietovyPortServera()
{
	return atoi(pisPort->napis);
}

void setSietovyPortServera(int n)
{
	sprintf(pisPort->napis,"%d",n);
}

void akciaNastaveniaSiete()
{
	akciaButton();

	if(isKlik(cudlikSpet)==1)
	{
		setMiesto_v_hre(MAIN_MENU);
	}

	if(isKlik(cudlikDalej)==1)
	{
		if(getNastaveniaSieteStav()==CLIENT)
		{
			initClient();
		}
		else
		{
			setMiesto_v_hre(VYBER_LEVEL);
		}
	}

	akciaCheck(cudlikNic);
	akciaCheck(cudlikServer);
	akciaCheck(cudlikClient);

	if(getStatus(cudlikClient)==CHECK_ANO)akciaTextfield(pisClient);
	if(getStatus(cudlikServer)==CHECK_ANO)akciaTextfield(pisServer);
	if(getStatus(cudlikNic)==CHECK_NIE)akciaTextfield(pisPort);

	if(isZmenilStav(cudlikNic))
	{
		stav=NONE;
		cudlikNic->status=CHECK_ANO;
		cudlikServer->status=CHECK_NIE;
		cudlikClient->status=CHECK_NIE;
		return;
	}

	if(isZmenilStav(cudlikClient))
	{
		stav=CLIENT;
		cudlikClient->status=CHECK_ANO;
		cudlikServer->status=CHECK_NIE;
		cudlikNic->status=CHECK_NIE;
		return;
	}

	if(isZmenilStav(cudlikServer))
	{
		stav=SERVER;
		cudlikServer->status=CHECK_ANO;
		cudlikNic->status=CHECK_NIE;
		cudlikClient->status=CHECK_NIE;
		return;
	}
}

void quitNastaveniaSiete()
{
	destroyLabel(napisStav);
	destroyLabel(napisNic);
	destroyLabel(napisServer);
	destroyLabel(napisClient);
	destroyLabel(napisNasClient);
	destroyLabel(napisNasServer);
	destroyLabel(napisNasPort);

	destroyCheck(cudlikNic);
	destroyCheck(cudlikServer);
	destroyCheck(cudlikClient);

	destroyTextfield(pisServer);
	destroyTextfield(pisClient);
	destroyTextfield(pisPort);

	destroyButton(cudlikSpet);
	destroyButton(cudlikDalej);
}
