
#include "interface.h"
#include "zbrane.h"
#include "bulanec.h"
#include "ikonky.h"
#include "panel.h"

static SDL_Surface *g_panel;
static SDL_Surface *g_naboj;
static SDL_Surface *g_bonus;
static SDL_Color farba_pisma = {255,255,255,0};// Barva textu

void initPanel()
{
	g_panel = loadImage(PATH_IMAGE "panel.png",1);
	g_naboj = loadImage(PATH_IMAGE "naboj.png",1);
	g_bonus = loadImage(PATH_IMAGE "cas_bonus.png",0);

}

void kresliPanel(bulanec *b2,bulanec *b1)
{
	//SDL_BlitSurface([Surfrace obrazka],[suradnice casti obrazka a rozmery obrazka],
	//[Surfrace okna],[poloha obrazka v okne]);
	
	SDL_Rect src_rect, dst_rect;
	SDL_Surface *text;
	char str[STR_SIZE];
	int width;
	int i;
	
	dst_rect.x=PANEL_POLOHA_X;
	dst_rect.y=PANEL_POLOHA_Y;
	
	SDL_BlitSurface(g_panel,NULL,screen, &dst_rect);
	

	dst_rect.x=PANEL_ZBRAN_IMAGE_VPRAVO_X;
	dst_rect.y=PANEL_ZBRAN_IMAGE_VPRAVO_Y;
	SDL_BlitSurface(getIkonkaZbran(b2->zbran),NULL,screen, &dst_rect);

	if(b2->bonus!=BONUS_NIC)
	{
		dst_rect.x=PANEL_GRAF_BONUS_VPRAVO_X;
		dst_rect.y=PANEL_GRAF_BONUS_VPRAVO_Y;

		src_rect.x=0;
		src_rect.y=0;
		src_rect.w=PANEL_GRAF_BONUS_SIZE_X;
		src_rect.h=PANEL_GRAF_BONUS_SIZE_Y;
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		src_rect.y=PANEL_GRAF_BONUS_SIZE_Y;
		src_rect.w=(b2->bonus==BONUS_NAVZDY?100:b2->casBonus/5);
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		dst_rect.x=PANEL_BONUS_IMAGE_VPRAVO_X;
		dst_rect.y=PANEL_BONUS_IMAGE_VPRAVO_Y;
		SDL_BlitSurface(getIkonkaBonus(b2->bonus),NULL,screen, &dst_rect);
	}

	src_rect.w=4;
	src_rect.h=8;
	src_rect.y=0;

	for(i=0;i<5;i++)
	{
		if(b2->naboje[b2->zbran]==0)break;

		if(b2->naboje[b2->zbran]>=i+1)src_rect.x=0;
		else src_rect.x=4;

		dst_rect.x = WINDOW_SIZE_X+5*i-43;
		dst_rect.y = (WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}

	src_rect.x=8;
	for(i=0;b2->nabijaSaZasobnik>0 && i<(100-b2->nabijaSaZasobnik)/10;i++)
	{
		dst_rect.x=WINDOW_SIZE_X+4*i-50;
		dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}

	if(b1!=NULL)
	{

	dst_rect.x=PANEL_ZBRAN_IMAGE_VLAVO_X;
	dst_rect.y=PANEL_ZBRAN_IMAGE_VLAVO_Y;
	SDL_BlitSurface(getIkonkaZbran(b1->zbran),NULL,screen, &dst_rect);

	if(b1->bonus!=BONUS_NIC)
	{
		dst_rect.x=PANEL_GRAF_BONUS_VLAVO_X;
		dst_rect.y=PANEL_GRAF_BONUS_VLAVO_Y;

		src_rect.x=0;
		src_rect.y=0;
		src_rect.w=PANEL_GRAF_BONUS_SIZE_X;
		src_rect.h=PANEL_GRAF_BONUS_SIZE_Y;
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		src_rect.y=PANEL_GRAF_BONUS_SIZE_Y;
		src_rect.w=(b1->bonus==BONUS_NAVZDY?100:b1->casBonus/5);
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		dst_rect.x=PANEL_BONUS_IMAGE_VLAVO_X;
		dst_rect.y=PANEL_BONUS_IMAGE_VLAVO_Y;
		SDL_BlitSurface(getIkonkaBonus(b1->bonus),NULL,screen, &dst_rect);
	}

	src_rect.w=4;
	src_rect.h=8;
	src_rect.y=0;

	for(i=0;i<5;i++)
	{
		if(b1->naboje[b1->zbran]==0)break;

		if(b1->naboje[b1->zbran]>=i+1)src_rect.x=0;
		else src_rect.x=4;

		dst_rect.x = 20+5*i;
		dst_rect.y = (WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}

	src_rect.x=8;
	for(i=0;b1->nabijaSaZasobnik>0 && i<(100-b1->nabijaSaZasobnik)/10;i++)
	{
		dst_rect.x=9+4*i;
		dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}
	}
	
	pridajPrekresli(&zoznamPrekresli,0,(WINDOW_SIZE_Y-PANEL_SIZE_Y),PANEL_SIZE_X,PANEL_SIZE_Y);

/*	
	pridajPrekresli(&zoznamPrekresli,0,(WINDOW_SIZE_Y-PANEL_SIZE_Y),50,50);
	pridajPrekresli(&zoznamPrekresli,WINDOW_SIZE_X-50,(WINDOW_SIZE_Y-PANEL_SIZE_Y),50,50);
*/

	if(b1!=NULL)
		sprintf(str,"%d : %d",b1->score,b2->score);
	else
		sprintf(str,"%d",b2->score);

	TTF_SizeUTF8(g_font,str,&width,NULL);
	text = TTF_RenderUTF8_Blended(g_font,str,farba_pisma);
	dst_rect.x=WINDOW_SIZE_X/2-width/2;
#ifdef WIN32
	dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+17;
#else
	dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+20; // pro helba - upravit
#endif
	SDL_BlitSurface(text,NULL,screen,&dst_rect);
	SDL_FreeSurface(text);
}

void quitPanel()
{
	SDL_FreeSurface(g_panel);
	SDL_FreeSurface(g_naboj);
	SDL_FreeSurface(g_bonus);
}

