
#include "interface.h"
#include "nastavenia.h"
#include "nastaveniaSiete.h"
#include "vyberLevel.h"
#include "bulanec.h"
#include "strela.h"
#include "vec.h"
#include "hraSa.h"
#include "suborLevel.h"
#include "zvuky.h"
#include "siet.h"
#include "jazyk.h"
#include "chat.h"

#ifdef UNIX_SOCKET

#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>

#endif

#ifdef UNIX_SOCKET
static int socketServer=-1;
#endif

#ifdef SDL_NET_SOCKET
static TCPsocket socketServer;
#endif

static client *myClient;

static int pocetClientov;
static int pocetKol;
static int koniec;

int getKoniecSiete()
{
	return koniec;
}

int getPocetkolVSietach()
{
	return pocetKol;
}

void rozpojSiet(int n)
{
	char str[STR_SIZE];
	int i;

	if(koniec==1)return;
	
	strcpy(str,"quit");

	printf("rozpajam siet..\n");

	if(getNastaveniaSieteStav()==SERVER)
	{
		if(n==ODODSLI_SPRAVU)odosliOstatnymClientom(str,VSETCI_CLIENTI);

		for(i=0;i<pocetClientov;i++)
#ifdef UNIX_SOCKET
			close(myClient[i].socket);
#endif

#ifdef SDL_NET_SOCKET
			SDLNet_TCP_Close(myClient[i].socket);
#endif


#ifdef UNIX_SOCKET
		close(socketServer);
#endif

#ifdef SDL_NET_SOCKET
		SDLNet_TCP_Close(socketServer);
#endif

		free(myClient);
	}

	if(getNastaveniaSieteStav()==CLIENT)
	{
		if(n==ODODSLI_SPRAVU)odosliServeru(str);

#ifdef UNIX_SOCKET
		close(socketServer);
#endif

#ifdef SDL_NET_SOCKET
		SDLNet_TCP_Close(socketServer);
#endif
	}

	koniec=1;
}

void spracuj(char *sprava)
{
	char cmd[STR_SIZE];
	char *s;
	bulanec *p;
	int a,b,c,d,e,f,g;

	//printf("spracujem  ->%s<-\n",sprava);

	SDL_LockMutex(mutex_akcia);

	if(strncmp(sprava,"init",4)==0)
	{
		char str[STR_SIZE];
		char suborLevel[STR_SIZE];

		sscanf(sprava,"%s %s %d %d %d",cmd,suborLevel,&b,&c,&d);
		printf("level : %s\npocet kol: %d\npocet hracov : %d\nja  som : %d\n",suborLevel,b,c,d);
		
		a=getCisloLevelu(suborLevel);
		pocetKol=b;
		
		if(a == CISLO_LEVELU_NENEAJDENE)
		{
			char str[STR_SIZE];
			printf("level %s - nenajdeny\n",suborLevel);
			
			strcmp(str,"error 1");
			odosliServeru(str);

			rozpojSiet(NEODODSLI_SPRAVU);
		}
		else
		{
			vytvorBulancov(c,d);
			nacitajLevel((char **)level[a].obsah);
			setMiesto_v_hre(HRA_SA);
			odstranSpravu();

			sprintf(str,"meno %d %s",getTuxKtorehoOvladam(),
			getbulanec(getTuxKtorehoOvladam())->meno);

			odosliServeru(str);
		}
	}

	if(strncmp(sprava,"pohyb",5)==0)
	{
		sscanf(sprava,"%s %d %d %d %d",cmd,&a,&b,&c,&d);
		p=getbulanec(a);

		if(p!=NULL)
		{
			p->x=b;
			p->y=c;
			p->otoceny=d;
			p->animaciaKrokov++;
			p->mrtvy=0;

			if(p->animaciaKrokov==MAX_ANIMACIA*POCET_KLIKNUTI_KLAVESY)
			{
				p->animaciaKrokov=0;
			}
		}
	}

	if(strncmp(sprava,"mrtvy",5)==0)
	{
		int i;

		sscanf(sprava,"%s %d",cmd,&a);
		p=getbulanec(a);

		if(p!=NULL)
		{
			for(i=0;i<POCET_ZBRANI;i++)
				p->naboje[i]=0;
	
			p->naboje[PISTOL]=MAX_POCET_STRIEL;

			p->zbran=PISTOL;
			p->otoceny=VPRAVO;
			p->mozeStrielat=0;
			p->nabijaSaZasobnik=0;
			p->mrtvy=1;
			p->bonus=BONUS_NIC;
			p->casBonus=0;
			p->mozePrehoditZbran=0;
			prehrajZvuk(ZVUK_SMRT);
		}
	}

	if(strncmp(sprava,"strela",6)==0)
	{
		sscanf(sprava,"%s %d",cmd,&a);
		p=getbulanec(a);

		if(p!=NULL)
		{
			strielbaBulanec(p);
		}
	}

	if(strncmp(sprava,"score",5)==0)
	{
		sscanf(sprava,"%s %d %d",cmd,&a,&b);

		if(p!=NULL)
		{
			p=getbulanec(a);
			p->score=b;
		}
	}

	if(strncmp(sprava,"kolo",4)==0)
	{
		sscanf(sprava,"%s %d",cmd,&a);
		setKolo(a);
	}

	if(strncmp(sprava,"chat",4)==0)
	{
		char chat_str[STR_SIZE];
		int len,i;

		sscanf(sprava,"%s %s",cmd,chat_str);
		printf("chat %s\n",chat_str);

		len=strlen(chat_str);

		for(i=0;i<len;i++)
			if(chat_str[i]=='_')chat_str[i]=' ';

		chatPridajRiadok(chat_str);
	}

	if(strncmp(sprava,"vec",3)==0)
	{
		sscanf(sprava,"%s %d %d %d",cmd,&a,&b,&c);
		pridajVec(&zoznamVeci,a,b,c,NULL);
	}

	if(strncmp(sprava,"zmenzbran",9)==0)
	{
		sscanf(sprava,"%s %d %d",cmd,&a,&b);
		p=getbulanec(a);

		if(p!=NULL)
		{
			p->zbran=b;
		}
	}

	if(strncmp(sprava,"pauza",5)==0)
	{
		sscanf(sprava,"%s %d",cmd,&a);
		zapniVypniPauzu();
	}

	if(strncmp(sprava,"meno",4)==0)
	{
		char meno[STR_SIZE];
		sscanf(sprava,"%s %d %s",cmd,&a,meno);
		p=getbulanec(a);
		strcpy(p->meno,meno);
	}

	if(strncmp(sprava,"odstranstrelu",13)==0)
	{
		sscanf(sprava,"%s %d",cmd,&a);
		odstranStrelu(a);
	}

	if(strncmp(sprava,"presunstrelu",12)==0)
	{
		strela *teraz;
		sscanf(sprava,"%s %d %d %d %d %d %d %d",cmd,&a,&b,&c,&d,&e,&f,&g);

		teraz=getStrela(a);

		if(teraz!=NULL)
		{
			pridajPrekresli(&zoznamPrekresli,teraz->x,teraz->y,teraz->w,teraz->h);
			
			teraz->x=b;
			teraz->y=c;
			teraz->px=d;
			teraz->py=e;
			teraz->smer=f;
			teraz->vidiet=g;
		}
	}

	if(strncmp(sprava,"prekresli",9)==0)
	{
		sscanf(sprava,"%s %d %d %d %d",cmd,&a,&b,&c,&d);
		pridajPrekresli(&zoznamPrekresli,a,b,c,d);
	}

	if(strncmp(sprava,"quit",4)==0)
	{
		printf("dostal som spravu na rozpojenie siete..\n");
		rozpojSiet(NEODODSLI_SPRAVU);
	}

	if(strncmp(sprava,"error",5)==0)
	{
		fprintf(stderr,"sprava => %s\n",sprava);
		rozpojSiet(NEODODSLI_SPRAVU);
	}

	SDL_UnlockMutex(mutex_akcia);

	if(strlen(sprava)>3 && (s=strstr(sprava,"\n"))!=NULL)spracuj(s+1);
}

#ifdef UNIX_SOCKET
int runServer(int sockfd)
#endif

#ifdef SDL_NET_SOCKET
int runServer(TCPsocket sockfd)
#endif
{
	char sprava[STR_SIZE];

#ifdef UNIX_SOCKET
	if (sockfd < 0)
#endif

#ifdef SDL_NET_SOCKET
	if (sockfd==NULL)
#endif
		puts("server: chyba pri ziskavani klientskeho socketu");
	else
		puts("Niekto sa pripojil..");

	while(koniec==0)
	{
		memset(sprava,0,STR_SIZE);

#ifdef UNIX_SOCKET
		if(recv(sockfd,sprava,STR_SIZE,0)<0)
#endif
#ifdef SDL_NET_SOCKET
		if(SDLNet_TCP_Recv(sockfd,sprava,STR_SIZE)<0)
#endif
		{
			puts("(runServer) spojenie prerusene!");
			return -1;
		}

		odosliOstatnymClientom(sprava,sockfd);
		spracuj(sprava);

		if(getKoniecSiete())return 0;
	}

	return 0;
}

int runClient(void *nic)
{
#ifdef SDL_NET_SOCKET
	IPaddress ip;
#endif

#ifdef UNIX_SOCKET
	struct sockaddr_in  serv_addr;

	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family=AF_INET;
	serv_addr.sin_addr.s_addr=inet_addr(getIPAdresaServera());
	serv_addr.sin_port=htons(getSietovyPortServera);
#endif 

	char sprava[STR_SIZE];

	koniec=0;

	zobrazSpravu(Text(TEXT_PRIPAJAM_SA_K_SERVERU));

#ifdef UNIX_SOCKET
	if ((socketServer = socket(AF_INET,SOCK_STREAM,0))<0)
#endif
#ifdef SDL_NET_SOCKET
 	if (SDLNet_ResolveHost(&ip,getIPAdresaServera(),getSietovyPortServera())==1)
#endif
	{
		fprintf(stderr,"CHYBA: nemozem otvorit socket\n");
		return -1; 
	}

	puts("pripajam sa..");  
 
	
#ifdef UNIX_SOCKET
	if (connect(socketServer,(struct sockaddr *)&serv_addr,sizeof(serv_addr))<0)
#endif
#ifdef SDL_NET_SOCKET
	if((socketServer=SDLNet_TCP_Open(&ip))==NULL)
#endif
	{
		fprintf(stderr,"CHYBA: nemozem sa pripojit\n");
		return -1;
	}

	puts("som pripojeny..");
	
	while(koniec==0)
	{
		memset(sprava,0,STR_SIZE);

#ifdef UNIX_SOCKET
		if(recv(socketServer,sprava,STR_SIZE,0)<0)
#endif
#ifdef SDL_NET_SOCKET
		if(SDLNet_TCP_Recv(socketServer,sprava,STR_SIZE)<0)
#endif
		{
			puts("(runClient) spojenie prerusene!");
			return -1;
		}

		spracuj(sprava);

		if(getKoniecSiete())return 0;
	}

	return 0;
}

void odosliServeru(char *s)
{
	int len;

	if(koniec==1)return;

	strcat(s,"\n");
	len=strlen(s);

#ifdef UNIX_SOCKET
	if(send(socketServer,s,len,0)<0)
#endif

#ifdef SDL_NET_SOCKET
	if(SDLNet_TCP_Send(socketServer,s,len)<0)
#endif
	{
		puts("(odosliServeru) spojenie prerusene!");
		return;
	}	
}

#ifdef UNIX_SOCKET
void odosliOstatnymClientom(char *s,int n)
#endif

#ifdef SDL_NET_SOCKET
void odosliOstatnymClientom(char *s,TCPsocket n)
#endif
{
	int len;
	int i;

	if(koniec==1)return;

	strcat(s,"\n");
	len=strlen(s);

	for(i=0;i<pocetClientov;i++)
	{

		if(myClient[i].socket!=n)
		{
#ifdef UNIX_SOCKET
			if(send(myClient[i].socket,s,len,0)<0)
#endif

#ifdef SDL_NET_SOCKET
			if(SDLNet_TCP_Send(myClient[i].socket,s,len)<0)
#endif
			{
				puts("(odosliOstatnymClientom) spojenie prerusene!");
				return;
			}
		}
	}
}

void odosliJednemuClientovy(char *s,int n)
{
	int len;

	if(koniec==1)return;

	strcat(s,"\n");
	len=strlen(s);

#ifdef UNIX_SOCKET
	if(send(myClient[n].socket,s,len,0)<0)
#endif

#ifdef SDL_NET_SOCKET
	if(SDLNet_TCP_Send(myClient[n].socket,s,len)<0)
#endif
	{
		puts("(odosliJednemuClientovy) spojenie prerusene!");
		return;
	}
}

void clientiSaPripajaju()
{
#ifdef SDL_NET_SOCKET
	IPaddress ip;
	TCPsocket server;
#endif

#ifdef UNIX_SOCKET
	int  clilen;
#endif
	char str[STR_SIZE];
	int i,j;

#ifdef UNIX_SOCKET
	struct sockaddr_in  cli_addr, serv_addr;
#endif

	myClient = malloc(sizeof(client)*pocetClientov);
	memset(myClient,0,sizeof(client)*pocetClientov);

#ifdef UNIX_SOCKET
	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family      = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port        = htons(getSietovyPortServera);
	clilen = sizeof(cli_addr);

	if ((socketServer = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		puts("server: nemozem otvorit socket");
		return;
	}

	if(bind(socketServer, (struct sockaddr *) &serv_addr, sizeof(serv_addr))<0)
	{
		puts("server: nemozem obsadit port");
		return;
	}

	listen(socketServer, 5);
#endif

#ifdef SDL_NET_SOCKET
	if (SDLNet_ResolveHost(&ip,NULL,getSietovyPortServera()))
	{
		puts("server: nemozem otvorit socket");
		return;
	}

	if((server=SDLNet_TCP_Open(&ip))==NULL)
	{
		puts("server: nemozem obsadit port");
		return;
	}
#endif

	puts("sedim na sietovom porte..");

	for(i=0;i<pocetClientov;i++)
	{
		sprintf(str,Text(TEXT_CAKAM_NA_PRIPOJENIE_KLIENTOV),i,pocetClientov);
		zobrazSpravu(str);
		kresli();

#ifdef UNIX_SOCKET
		myClient[i].socket = accept(socketServer, (struct sockaddr *) &cli_addr,&clilen);
#endif

#ifdef SDL_NET_SOCKET
		do{
			myClient[i].socket = SDLNet_TCP_Accept(server);
			SDL_Delay(100);
		}while(myClient[i].socket==NULL);
#endif
		myClient[i].thread=SDL_CreateThread(runServer,myClient[i].socket);

		printf("hrac %d pripojeny...\n",i+1);
	}

	for(i=0;i<pocetClientov;i++)
	{
		sprintf(str,"init %s %d %d %d",
		level[getVybranyLevel()].nazov,
		pocetKol,
		getPocetHracovKtoriSaPripoja()+1,
		i+1);

		odosliJednemuClientovy(str,i);

		sprintf(str,"meno %d %s",getTuxKtorehoOvladam(),
		getbulanec(getTuxKtorehoOvladam())->meno);

		odosliJednemuClientovy(str,i);

		sprintf(str,"pauza 1");
		odosliJednemuClientovy(str,i);

		for(j=0;armadaBulancov[j]!=NULL;j++)
		{
			sprintf(str,"pohyb %d %d %d %d",armadaBulancov[j]->id,
			armadaBulancov[j]->x,armadaBulancov[j]->y,
			armadaBulancov[j]->otoceny);
			odosliJednemuClientovy(str,i);
		}
	}

	pridajZbran();
	zapniVypniPauzu();

	odstranSpravu();
}

void initClient()
{
	koniec=0;

	SDL_CreateThread(runClient,NULL);
}

void initServer()
{
	koniec=0;
	pocetClientov=getPocetHracovKtoriSaPripoja();
	pocetKol=getNastaveniaPocetKol();

	SDL_CreateThread(clientiSaPripajaju,NULL);
}
