

#include "interface.h"
#include "jazyk.h"
#include "suborLevel.h"

suborLevel *level;
static int pocetLevelov;

void initSuborLevelov()
{
	DIR *adresar;
	struct dirent *subor;
	char str[STR_SIZE];
	int i;

	adresar=opendir(PATH_DATA);

	pocetLevelov=0;

	while((subor=readdir(adresar))!=NULL)
	{
		if(strstr(subor->d_name,NAZOV_SUBORU)!=NULL &&
		subor->d_name[strlen(subor->d_name)-1]!='~')
		{
			pocetLevelov++;
		}
	}

	closedir(adresar);

	level = malloc(sizeof(suborLevel)*(pocetLevelov+1));
	memset(level,0,sizeof(suborLevel)*(pocetLevelov+1));

	adresar=opendir(PATH_DATA);
	i=0;

	while((subor=readdir(adresar))!=NULL)
	{
		if(strstr(subor->d_name,NAZOV_SUBORU)!=NULL &&
		subor->d_name[strlen(subor->d_name)-1]!='~')
		{
			sprintf(str,"%s%s",PATH_DATA,subor->d_name);

			strcpy(level[i].nazov,subor->d_name);
			level[i].obsah=loadSubor(str);
		
			if(level[i].obsah!=NULL)
				printf("level %s nacitany\n",subor->d_name);
			else
				fprintf(stderr,"level %d sa nepodarilo nacitat!\n",i+1);

			i++;
		}
	}

	closedir(adresar);
}

int getPocetLevelov()
{
	return pocetLevelov;
}

int getCisloLevelu(char *s)
{
	int i;

	for(i=0;i<pocetLevelov;i++)
	{
		if(strcmp(level[i].nazov,s)==0)return i;
	}

	return CISLO_LEVELU_NENEAJDENE;
}

char *getNazovLevelu(int n)
{
	int i;
	char prikaz[STR_SIZE];

	strcpy(prikaz,PRIKAZ_TITLE " ");
	strcat(prikaz,getJazykStr());

	for(i=0;level[n].obsah[i]!=NULL;i++)
	{
		if(strncmp(level[n].obsah[i],prikaz,strlen(prikaz))==0)
		{
			return level[n].obsah[i]+strlen(prikaz);
		}
	}

	return NAZNAMI_NAZOV_LEVELU;
}

char *getScreenLevelu(int n)
{
	int i;
	char prikaz[STR_SIZE];

	strcpy(prikaz,PRIKAZ_SCREEN);

	for(i=0;level[n].obsah[i]!=NULL;i++)
	{
		if(strncmp(level[n].obsah[i],prikaz,strlen(prikaz))==0)
		{
			return level[n].obsah[i]+strlen(prikaz)+1;
		}
	}

	return NEZNAMI_SCREEN_LEVELU;
}

char *getScreenShadowLevelu(int n)
{
	int i;
	char prikaz[STR_SIZE];

	strcpy(prikaz,PRIKAZ_SCREENSHADOW);

	for(i=0;level[n].obsah[i]!=NULL;i++)
	{
		if(strncmp(level[n].obsah[i],prikaz,strlen(prikaz))==0)
		{
			return level[n].obsah[i]+strlen(prikaz)+1;
		}
	}

	return NEZNAMI_SCREENSHADOW_LEVELU;
}

void quitSuborLevel()
{
	int i;

	for(i=0;i<pocetLevelov;i++)
	{
		destroySubor(level[i].obsah);
	}
	
	free(level);
}
