
#ifndef SUBORLEVEL_H

#define SUBORLEVEL_H

typedef struct str_suborLevel
{
	char nazov[STR_SIZE];
	char ** obsah;
} suborLevel;

#define NAZOV_SUBORU "level"
#define NAZNAMI_NAZOV_LEVELU "???"
#define NEZNAMI_SCREEN_LEVELU "no_image.png"
#define NEZNAMI_SCREENSHADOW_LEVELU "no_image-shadow.png"
#define CISLO_LEVELU_NENEAJDENE -1

#define PRIKAZ_SETPLOCHA "SETPLOCHA"
#define PRIKAZ_SETPLOCHA_DLZKA 9

#define PRIKAZ_ADD "ADD"
#define PRIKAZ_ADD_DLZKA 3

#define PRIKAZ_ANIMACIA "ANIMACIA"
#define PRIKAZ_ANIMACIA_DLZKA 8

#define PRIKAZ_ROBOT "ROBOT"
#define PRIKAZ_ROBOT_DLZKA 5

#define PRIKAZ_TELEPORT "TELEPORT"
#define PRIKAZ_TELEPORT_DLZKA 8

#define PRIKAZ_TRUBKA "TRUBKA"
#define PRIKAZ_TRUBKA_DLZKA 6

#define PRIKAZ_SETMUSIC "SETMUSIC"
#define PRIKAZ_SETMUSIC_DLZKA 8

#define PRIKAZ_TITLE "TITLE"
#define PRIKAZ_TITLE_DLZKA 5

#define PRIKAZ_SETDIERA "SETDIERA"
#define PRIKAZ_SETDIERA_DLZKA 8

#define PRIKAZ_SCREEN "SCREEN"
#define PRIKAZ_SCREENSHADOW "SCREENSHADOW"

/*
 * premenna zo vsetkymi zdrojakmi levelov, ulozenych v subore ./data/level*
 * zdrojakyLevelov[A][B][C]
 *
 * [A] - cislo levelu level1 az levelN, na konci NULL
 * [B] - index riadka v level, na konci NULL
 * [C] - index znaku v danom riadku, na konci '\0'
 */
extern suborLevel *level;

/*
 * Nacita vsetky subory level* v adresari ./data/
 * do pointera zdrojakyLevelov
 */
extern void initSuborLevelov();

extern char ** loadSuborLevel(char *s);

/*
 * Vrati pocet levelv (ake necakane, ze?)
 */
extern int getPocetLevelov();

extern int getCisloLevelu(char *s);

/*
 * vrati pointer na retazc, ktory obsahuje nazov levelu s cislom n
 */
extern char *getNazovLevelu(int n);

extern char *getScreenLevelu(int n);

extern char *getScreenShadowLevelu(int n);

/*
 * Pdstrani pointer zdrojakyLevelov
 */
extern void quitSuborLevel();

#endif

