
#include "interface.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "vec.h"
#include "animacia.h"
#include "zvuky.h"
#include "nastaveniaSiete.h"

#ifdef NET_MULTIPLAYER
#include "siet.h"
#endif

vec *zoznamVeci;

void initVec()
{
	zoznamVeci=NULL;
}

void pridajVec(vec **p,int x,int y,int co,bulanec *autor)
{
	vec *teraz;

	teraz=malloc(sizeof(vec));
	teraz->x=x;
	teraz->y=y;
	teraz->co=co;
	teraz->g=veciSurface[co];
	teraz->policko=0;
	teraz->data1=0;
	teraz->data2=0;
	teraz->autor=autor;

	teraz->next=*p;

	if(co>=PISTOL && co<=BOMBA)
	{
		teraz->w=VEC_ZBRAN_SIZE_X;
		teraz->h=VEC_ZBRAN_SIZE_Y;
		teraz->maxPolicko=VEC_MAX_ANIMACIA;
		teraz->cas=CAS_KEDY_VEC_ZMIZNE;
	}

	if(co==MINA)
	{
		teraz->w=MINA_SIZE_X;
		teraz->h=MINA_SIZE_Y;
		teraz->maxPolicko=1;
		teraz->cas=CAS_KEDY_VEC_ZMIZNE_NIKDY;
	}

	if(co>=BONUS_RYCHLOST && co<=BONUS_NEVYDITELNY)
	{
		teraz->w=BONUS_SIZE_X;
		teraz->h=BONUS_SIZE_Y;
		teraz->maxPolicko=BONUS_MAX_ANIMACIA;
		teraz->cas=CAS_KEDY_VEC_ZMIZNE;
	}

	if(co==VYBUCH)
	{
		teraz->w=VYBUCH_SIZE_X;
		teraz->h=VYBUCH_SIZE_Y;
		teraz->maxPolicko=VYBUCH_MAX_ANIMACIA;
		teraz->cas=CAS_KEDY_VEC_ZMIZNE_NIKDY;
		prehrajZvuk(ZVUK_MINA);	
	}

	if(co==MAX_VYBUCH)
	{
		teraz->w=MAX_VYBUCH_SIZE_X;
		teraz->h=MAX_VYBUCH_SIZE_Y;
		teraz->maxPolicko=MAX_VYBUCH_MAX_ANIMACIA;
		teraz->cas=CAS_KEDY_VEC_ZMIZNE_NIKDY;
		prehrajZvuk(ZVUK_MINA);
	}

	*p=teraz;

}

void zobrazZbran(vec **p,bulanec *b)
{
	int x,y,w,h;
	
	vec *teraz;
	vec *pred;
	vec *del;
	int pridaj=0; //mam na konci pridat zbran?
	int zmaz=0; //mam na konci pridat zbran?

	if(b->mrtvy!=0)return;

	teraz=*p;
	pred=NULL;

	while(teraz!=NULL)
	{
		getRozmery(b,&x,&y,&w,&h);

		//nastala kolizia
		if(koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,teraz->w,teraz->h)==1)
		{
			//tuto vec (teraz) zatial nezmaz
			zmaz=0;

			//zober pistol
			if(teraz->co>=PISTOL && teraz->co<=BOMBA)
			{
				b->zbran=teraz->co;
				
				if(teraz->co==BOMBA) b->naboje[b->zbran]+=MAX_POCET_MIN;
				else b->naboje[b->zbran]+=MAX_POCET_STRIEL;
				
				b->mozeStrielat=0;
				b->nabijaSaZasobnik=0;

				prehrajZvuk(ZVUK_ZBRAN);
				zmaz=1;
			}

			//aktivuj minu
			if(teraz->co==MINA && b->bonus!=BONUS_DUCH && b->mrtvy==0 && teraz->data1==0)
			{
				//printf("mina odistena\n");
				prehrajZvuk(ZVUK_MINA_AKTIVOVANA);
				teraz->data1=AKTIVUJ_MINU;
				teraz->data2=VYBUCH;
			}

			//vybuch ta zabije ak este nie si mrtvy
			if((teraz->co==VYBUCH || teraz->co==MAX_VYBUCH) && b->mrtvy==0)
			{
				if(getNastaveniaSieteStav()==NONE)
				{
    					if(b==armadaBulancov[ACTIVE_BULANEC1])
					{
						armadaBulancov[ACTIVE_BULANEC2]->score++;
					}

    					if(b==armadaBulancov[ACTIVE_BULANEC2])
					{
						armadaBulancov[ACTIVE_BULANEC1]->score++;
					}
				}
				else
				{
					if(teraz->autor!=NULL && teraz->autor!=b)teraz->autor->score++;
#ifdef NET_MULTIPLAYER
					if(getNastaveniaSieteStav()==SERVER)
					{
						char str[STR_SIZE];
						sprintf(str,"score %d %d",
						teraz->autor->id,teraz->autor->score);
						odosliOstatnymClientom(str,VSETCI_CLIENTI);
					}
#endif
				}

				pridajPrekresli(&zoznamPrekresli,x,y,w,h);
				kresliBulanec(b);

				prehrajZvuk(ZVUK_SMRT);

#ifdef NET_MULTIPLAYER
				if(getNastaveniaSieteStav()==SERVER)
				{
					char str[STR_SIZE];
					sprintf(str,"mrtvy %d",b->id);
					odosliOstatnymClientom(str,VSETCI_CLIENTI);
				}
#endif
				b->mrtvy=1;
			}

			//zober bonus
			if(teraz->co>=BONUS_RYCHLOST && teraz->co<=BONUS_NEVYDITELNY)
			{
				b->bonus=teraz->co;
				b->casBonus=CAS_TRVANIA_BONUSU;
				prehrajZvuk(ZVUK_BONUS);
				zmaz=1;
			}

			if(zmaz==1)
			{
				pridajPrekresli(&zoznamPrekresli,teraz->x-10,
				teraz->y-10,teraz->w+10,teraz->h+10);
		
				if(pred!=NULL)
				{
					pred->next=teraz->next;
					del=teraz;
					teraz=teraz->next;
					free(del);
					continue;
				}
				else
				{
					del=zoznamVeci;
					zoznamVeci=zoznamVeci->next;
					teraz=teraz->next;
					free(del);
					continue;
				}
			}
		}
		
		pred=teraz;
		teraz=teraz->next;
	}

	if(pridaj)pridajZbran();
}

int koliziaStrelaVec()
{
	vec *terazVec;
	strela *terazStrela;
	strela *del;
	strela *pred;

	terazVec=zoznamVeci;
	
	while(terazVec!=NULL)
	{
		terazStrela=zoznamStrel;
		pred=NULL;

		while(terazStrela!=NULL)
		{
			if(terazStrela->prejde==0 && terazVec->co==MINA && terazVec->data1==0 &&
			   koliziaObdlznikov(terazVec->x,terazVec->y,
			   terazVec->w,terazVec->h,
			   terazStrela->x,terazStrela->y,
			   terazStrela->w,terazStrela->h))
			{
				prehrajZvuk(ZVUK_MINA_AKTIVOVANA);
				terazVec->data1=AKTIVUJ_MINU;
				terazVec->data2=MAX_VYBUCH;

				if(pred!=NULL)
				{
					pred->next=terazStrela->next;
					del=terazStrela;
					terazStrela=terazStrela->next;
					free(del);
					continue;
				}
				else
				{
					del=zoznamStrel;
					zoznamStrel=zoznamStrel->next;
					terazStrela=terazStrela->next;
					free(del);
					continue;
				}
			}

			pred=terazStrela;
			terazStrela=terazStrela->next;
		}

		terazVec=terazVec->next;
	}

	return 0;
}

void akciaVec(vec **p)
{
	vec *teraz;
	vec *pred;
	vec *del;

	pred=NULL;
	teraz=*p;

	while(teraz!=NULL)
	{
		//daj dlasie policko
		teraz->policko++;

		//odrataj cas, kedy ma vec zmiznut
		if(teraz->cas>0)teraz->cas--;

		//ak sme prepebhli vsetky policka, tak od zaciatku
		if(teraz->policko==teraz->maxPolicko*RYCHLOST_ANIMACIE)
		{
			teraz->policko=0;
			//ak je to vybuch, tak ten sa odstrani
			if(teraz->co==VYBUCH || teraz->co==MAX_VYBUCH)teraz->cas=0;
		}

		//ak je miona aktivovana, pocitaj, kedy vybuchne
		if(teraz->co==MINA && teraz->data1>=AKTIVUJ_MINU)
		{
			teraz->data1++;
		}

		//ak ma mina vybuchnut, zmen sa na vybuch
		if(teraz->data1==MINA_TERAZ_VYBUCHNE && teraz->co==MINA)
		{
			teraz->co=teraz->data2;
			teraz->policko=0;
			teraz->data1=0;
			teraz->data2=0;

			teraz->x+=teraz->w/2;
			teraz->y+=teraz->h/2;

			if(teraz->co==VYBUCH)
			{
				teraz->g=veciSurface[VYBUCH];
				teraz->w=VYBUCH_SIZE_X;
				teraz->h=VYBUCH_SIZE_Y;
				teraz->maxPolicko=VYBUCH_MAX_ANIMACIA;
			}

			if(teraz->co==MAX_VYBUCH)
			{
				teraz->g=veciSurface[MAX_VYBUCH];
				teraz->w=MAX_VYBUCH_SIZE_X;
				teraz->h=MAX_VYBUCH_SIZE_Y;
				teraz->maxPolicko=MAX_VYBUCH_MAX_ANIMACIA;
			}

			teraz->x-=teraz->w/2;
			teraz->y-=teraz->h/2;

			teraz->cas=CAS_KEDY_VEC_ZMIZNE_NIKDY;
			prehrajZvuk(ZVUK_MINA);
		}

		//ak cas, kedy ma vec posobit skoncila, odstran vec
		if(teraz->cas==0)
		{
			pridajPrekresli(&zoznamPrekresli,teraz->x-10,
			teraz->y-10,teraz->w+10,teraz->h+10);

			if(pred!=NULL)
			{
				pred->next=teraz->next;
				del=teraz;
				teraz=teraz->next;
				free(del);
				continue;
			}
			else
			{
				del=zoznamVeci;
				zoznamVeci=zoznamVeci->next;
				teraz=teraz->next;
				free(del);
				continue;
			}
		}

		pred=teraz;
		teraz=teraz->next;
	}
}

void kresliVec(vec **p)
{
	vec *teraz;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		pridajImage(&zoznamImage,teraz->g,teraz->x,teraz->y,
		teraz->w,teraz->h,teraz->w*(teraz->policko/RYCHLOST_ANIMACIE),0,teraz->w,teraz->h,
		(teraz->co==VYBUCH||teraz->co==MAX_VYBUCH?
		VRSTVA_NAD_TUXANCOM:VRSTVA_S_TUXANCOM),PREKRESLI_RAMEC);

		teraz=teraz->next;
	}
}

void quitVec(vec **p)
{
	vec *teraz;
	vec *del;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		teraz=teraz->next;
		free(del);
	}

	//zoznamVeci=NULL;
	*p=NULL;
}
