
#include "interface.h"
#include "kurzor.h"
#include "widget_button.h"
#include "widget_label.h"
#include "jazyk.h"
#include "vyhodnotenie.h"
#include "mainMenu.h"

static wid_button *cudlikOk;

static wid_label **mena;
static wid_label **score;
static int pocet;

void initVyhodnotenie()
{
	cudlikOk = newButton(WINDOW_SIZE_X/2-BUTTON_SIZE_X/2,WINDOW_SIZE_Y-75,"Ok");
	pocet=0;
}

void noveVyhodnotenie(int n)
{
	int i;

	pocet=n;

	mena=malloc(pocet*sizeof(wid_label *));
	memset(mena,0,pocet*sizeof(wid_label *));
	
	score=malloc(pocet*sizeof(wid_label *));
	memset(mena,0,pocet*sizeof(wid_label *));

	for(i=0;i<pocet;i++)
	{
		mena[i]=newLabel(WINDOW_SIZE_X/2-100,150+i*20,LABEL_RIGHT,"???");
		score[i]=newLabel(WINDOW_SIZE_X/2+100,150+i*20,LABEL_RIGHT,"-1");
	}
}

void odstranVyhodnotenie()
{
	int i;

	for(i=0;i<pocet;i++)
	{
		destroyLabel(mena[i]);
		destroyLabel(score[i]);
	}

	free(mena);
	free(score);
}

void kresliVyhodnotenie()
{
	SDL_Rect dst_rect;
	int i;

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(getTapeta(),NULL,screen, &dst_rect);

	for(i=0;i<pocet;i++)
	{
		kresliLabel(mena[i]);
		kresliLabel(score[i]);
		//printf("%d\n",mena[i]->x);
	}
	
	kresliButton(cudlikOk);

	kresliKurzor();

	pridajPrekresli(&zoznamPrekresli,0,0,WINDOW_SIZE_X,WINDOW_SIZE_Y);
}

void pridajVyhodnotenie(char *s,int x)
{
	int i;

	strcpy(mena[pocet-1]->napis,s);
	sprintf(score[pocet-1]->napis,"%d",x);
	zmenLabel(mena[pocet-1]);
	zmenLabel(score[pocet-1]);

	for(i=pocet-1;i>=1;i--)
	{
		if(atoi(score[i]->napis)>atoi(score[i-1]->napis))
		{
			char menoz[STR_SIZE];
			char scorez[STR_SIZE];

			strcpy(menoz,mena[i]->napis);
			strcpy(scorez,score[i]->napis);

			strcpy(mena[i]->napis,mena[i-1]->napis);
			strcpy(score[i]->napis,score[i-1]->napis);
			zmenLabel(mena[i]);
			zmenLabel(score[i]);

			strcpy(mena[i-1]->napis,menoz);
			strcpy(score[i-1]->napis,scorez);
			zmenLabel(mena[i-1]);
			zmenLabel(score[i-1]);
		}
	}
}

void akciaVyhodnotenie()
{
	akciaButton();

	if(isKlik(cudlikOk)==1)
	{
		odstranVyhodnotenie();
		setMiesto_v_hre(MAIN_MENU);
	}
}

void quitVyhodnotenie()
{
	destroyButton(cudlikOk);
}
