
#include "interface.h"
#include "widget_check.h"

static SDL_Surface *g_check;
static SDL_Color farba_pisma = {255,255,255,0};// Barva textu

void initCheck()
{
	g_check = loadImage(PATH_IMAGE "skrk.png",1);
}

wid_check* newCheck(int x,int y,int n)
{
	wid_check *teraz;
	teraz = malloc(sizeof(wid_check));
	teraz->x=x;
	teraz->y=y;
	teraz->status=n;
	teraz->casKlik=0;
	teraz->zmenilStav=0;
	teraz->zapnuty=CHECK_ZAPNUTY;
	
	strcpy(teraz->popis,"");
	teraz->popisX=-1;
	teraz->popisY=-1;

	return teraz;
}

void destroyCheck(wid_check *p)
{
	free(p);
}

void setCheckPopis(wid_check *p,int x,int y,char *s)
{
	p->popisX=x;
	p->popisY=y;
	strcpy(p->popis,s);
}

void kresliCheck(wid_check *p)
{
	int x,y;
	char str1[STR_SIZE];
	char str2[STR_SIZE];
	char *s;

	SDL_Rect src_rect;
	SDL_Rect dst_rect;
	SDL_Surface *text;

	dst_rect.x=p->x;
	dst_rect.y=p->y;

	src_rect.x=(p->status==1?0:CHECK_SIZE_X);
	if(p->zapnuty==CHECK_VYPNUTY)src_rect.x+=CHECK_SIZE_X*2;

	src_rect.y=0;
	src_rect.w=CHECK_SIZE_X;
	src_rect.h=CHECK_SIZE_Y;

	SDL_BlitSurface(g_check,&src_rect,screen,&dst_rect);

	SDL_GetMouseState(&x,&y);

	if(p->zapnuty==CHECK_ZAPNUTY && x>p->x && y>p->y && x<p->x+CHECK_SIZE_X && y<p->y+CHECK_SIZE_Y)
	{
		strcpy(str1,p->popis);
		strcpy(str2,"");

		if((s=strchr(str1,'<'))!=NULL)
		{
			strcpy(str2,s+1);
			*s='\0';
		}

		dst_rect.x=p->popisX;
		dst_rect.y=p->popisY;

		text = TTF_RenderUTF8_Blended(g_font,str1,farba_pisma);
		SDL_BlitSurface(text,NULL,screen,&dst_rect);
		SDL_FreeSurface(text);

		dst_rect.y+=20;

		text = TTF_RenderUTF8_Blended(g_font,str2,farba_pisma);
		SDL_BlitSurface(text,NULL,screen,&dst_rect);
		SDL_FreeSurface(text);
	}
}

void akciaCheck(wid_check *p)
{
	int x,y;

	SDL_GetMouseState(&x,&y);

	if(p->zapnuty==0)return;

	if(p->casKlik>0)p->casKlik--;

	if(p->casKlik==0 && x>p->x && y>p->y && x<p->x+CHECK_SIZE_X && y<p->y+CHECK_SIZE_Y)
	{
		if((SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT)))
		{
			if(p->status==1)p->status=0;
			else p->status=1;

			p->zmenilStav=1;
			p->casKlik=10;
		}
	}
}

int getStatus(wid_check *p)
{
	return p->status;
}

int isZmenilStav(wid_check *p)
{
	int ret;
	ret=p->zmenilStav;
	p->zmenilStav=0;
	return ret;
}

void quitCheck()
{
	SDL_FreeSurface(g_check);
}

